=== modified file 'BRANCH.TODO'
--- BRANCH.TODO	2006-02-10 12:53:39 +0000
+++ BRANCH.TODO	2006-02-17 04:17:09 +0000
@@ -2,18 +2,3 @@
 # It should ALWAYS be empty in the mainline or in integration branches.
 # 
 
-When merging:
- * add news - fixed --one with testskipped
-   branch formats are now tested uniformly, preventing regressions as new
-   formats come online.
- * add news upgrade on url works
- * add testing news - branch_implementations
- * add testing news - testcasewithtransport
- * add testing news - workingtree_implementations
- * add testing news - repository_implementations
- * add testing news skips with --one
- * document WorkingTree.create, branch.create, workingtree.create_standalone, branch.init deprecation.
-
-Before considering it finished.:
- * cleanup remnans of check_format in the BzrBranch constructor.
- * check to use BzrDir 

=== modified file 'NEWS'
--- NEWS	2006-02-17 13:57:25 +0000
+++ NEWS	2006-02-21 01:05:33 +0000
@@ -1,4 +1,5 @@
 bzr development version
+ 
 
   IMPROVEMENTS:
 
@@ -18,6 +19,8 @@
       reflect user config now being stored in .bazaar (Hans Ulrich
       Niedermann)
 
+    * pull now accepts a --revision argument (Erik Bågfors)
+
     * 'bzr re-sign' now allows multiple revisions to be supplied on the command
       line. You can now use the following command to sign all of your old commits.
         find .bzr/revision-store// -name my@email-* \
@@ -52,11 +55,30 @@
 
     * Using Tree Transform for merge, revert, tree-building
 
+    * WorkingTree.create, Branch.create, WorkingTree.create_standalone,
+      Branch.initialize are now deprecated. Please see BzrDir.create_* for
+      replacement API's. (Robert Collins)
+
+    * New BzrDir class represents the .bzr control directory and manages
+      formatting issues. (Robert Collins)
+
   TESTING:
 
     * SFTP tests now shortcut the SSH negotiation, reducing test overhead
       for testing SFTP protocol support. (Robey Pointer)
 
+    * Branch formats are now tested once per implementation (see bzrlib.
+      tests.branch_implementations. This is analagous to the transport
+      interface tests, and has been followed up with working tree,
+      repository and BzrDir tests. (Robert Collins)
+
+    * New test base class TestCaseWithTransport provides a transport aware
+      test environment, useful for testing any transport-interface using
+      code. The test suite option --transport controls the transport used
+      by this class (when its not being used as part of implementation
+      contract testing). (Robert Collins)
+
+
 bzr 0.7rc1 2006-01-09
 
   CHANGES:

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2006-01-19 23:14:42 +0000
+++ bzrlib/__init__.py	2006-02-16 02:53:00 +0000
@@ -16,7 +16,6 @@
 
 """bzr library"""
 
-BZRDIR = ".bzr"
 
 # please keep these sorted (in C locale order) to aid merging
 DEFAULT_IGNORE = [

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2006-02-11 11:58:06 +0000
+++ bzrlib/add.py	2006-02-16 02:53:00 +0000
@@ -123,7 +123,7 @@
 
         mutter("smart add of %r, abs=%r", f, af)
         
-        if is_control_file(af):
+        if tree.is_control_filename(af):
             raise ForbiddenFileError('cannot add control file %s' % f)
             
         versioned = (inv.path2id(rf) != None)
@@ -152,7 +152,7 @@
         if kind == 'directory' and recurse and not sub_tree:
             for subf in os.listdir(af):
                 subp = bzrlib.osutils.pathjoin(rf, subf)
-                if subf == bzrlib.BZRDIR:
+                if tree.is_control_filename(subp):
                     mutter("skip control directory %r", subp)
                 else:
                     ignore_glob = tree.is_ignored(subp)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2006-02-14 17:19:40 +0000
+++ bzrlib/branch.py	2006-02-21 01:05:33 +0000
@@ -502,29 +502,6 @@
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
 
-    def _find_modes(self, t):
-        """Determine the appropriate modes for files and directories.
-        
-        FIXME: When this merges into, or from storage,
-        this code becomes delgatable to a LockableFiles instance.
-
-        For now its cribbed and returns (dir_mode, file_mode)
-        """
-        try:
-            st = t.stat('.')
-        except errors.TransportNotPossible:
-            dir_mode = 0755
-            file_mode = 0644
-        else:
-            dir_mode = st.st_mode & 07777
-            # Remove the sticky and execute bits for files
-            file_mode = dir_mode & ~07111
-        if not BzrBranch._set_dir_mode:
-            dir_mode = None
-        if not BzrBranch._set_file_mode:
-            file_mode = None
-        return dir_mode, file_mode
-
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         raise NotImplementedError(self.initialized)
@@ -597,11 +574,10 @@
         if not _found:
             # we are being called directly and must probe.
             raise NotImplementedError
-        transport = a_bzrdir.get_branch_transport(self)
-        control_files = LockableFiles(transport, 'branch-lock')
         return BzrBranch(_format=self,
-                         _control_files=control_files,
-                         a_bzrdir=a_bzrdir)
+                         _control_files=a_bzrdir._control_files,
+                         a_bzrdir=a_bzrdir,
+                         _repository=a_bzrdir.open_repository())
 
 
 class BzrBranchFormat5(BranchFormat):
@@ -610,7 +586,8 @@
     This format has:
      - a revision-history file.
      - a format string
-     - a lock lock file.
+     - a lock file.
+     - works with shared repositories.
     """
 
     def get_format_string(self):
@@ -654,7 +631,8 @@
         control_files = LockableFiles(transport, 'lock')
         return BzrBranch(_format=self,
                          _control_files=control_files,
-                         a_bzrdir=a_bzrdir)
+                         a_bzrdir=a_bzrdir,
+                         _repository=a_bzrdir.find_repository())
 
 
 class BranchReferenceFormat(BranchFormat):
@@ -752,7 +730,7 @@
 
     def __init__(self, transport=DEPRECATED_PARAMETER, init=DEPRECATED_PARAMETER,
                  relax_version_check=DEPRECATED_PARAMETER, _format=None,
-                 _control_files=None, a_bzrdir=None):
+                 _control_files=None, a_bzrdir=None, _repository=None):
         """Create new branch object at a particular location.
 
         transport -- A Transport object, defining how to access files.
@@ -806,8 +784,7 @@
                  "Please use Branch.open, or bzrdir.open_branch().",
                  DeprecationWarning,
                  stacklevel=2)
-        # TODO change this to search upwards if needed.
-        self.repository = self.bzrdir.open_repository()
+        self.repository = _repository
 
     def __str__(self):
         return '%s(%r)' % (self.__class__.__name__, self.base)

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2006-02-17 13:57:25 +0000
+++ bzrlib/builtins.py	2006-02-21 01:05:33 +0000
@@ -714,9 +714,8 @@
     
     @display_command
     def run(self, branch=None):
-        import info
-        b = WorkingTree.open_containing(branch)[0].branch
-        info.show_info(b)
+        import bzrlib.info
+        bzrlib.info.show_bzrdir_info(bzrdir.BzrDir.open_containing(branch)[0])
 
 
 class cmd_remove(Command):
@@ -819,7 +818,7 @@
             # locations if the user supplies an extended path
             if not os.path.exists(location):
                 os.mkdir(location)
-        WorkingTree.create_standalone(location)
+        bzrdir.BzrDir.create_standalone_workingtree(location)
 
 
 class cmd_diff(Command):
@@ -1451,7 +1450,15 @@
 
         if c.needs_write:
             c.write()
-            
+
+
+def get_format_type(typestring):
+    """Parse and return a format specifier."""
+    if typestring == "metadir":
+        return bzrdir.BzrDirMetaFormat1
+    msg = "No known bzr-dir format %s. Supported types are: metadir\n" %\
+        (typestring)
+    raise BzrCommandError(msg)
 
 
 class cmd_upgrade(Command):
@@ -1462,10 +1469,18 @@
     during other operations to upgrade.
     """
     takes_args = ['url?']
-
-    def run(self, url='.'):
+    takes_options = [
+                     Option('format', 
+                            help='Upgrade to a specific format rather than the'
+                                 ' current default format. Currently this '
+                                 ' option only accepts =metadir',
+                            type=get_format_type),
+                    ]
+
+
+    def run(self, url='.', format=None):
         from bzrlib.upgrade import upgrade
-        upgrade(url)
+        upgrade(url, format)
 
 
 class cmd_whoami(Command):

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2006-02-14 06:52:21 +0000
+++ bzrlib/bzrdir.py	2006-02-17 04:17:09 +0000
@@ -21,18 +21,32 @@
 """
 
 from copy import deepcopy
+import os
 from cStringIO import StringIO
 from unittest import TestSuite
 
-
 import bzrlib
 import bzrlib.errors as errors
 from bzrlib.lockable_files import LockableFiles
 from bzrlib.osutils import safe_unicode
+from bzrlib.osutils import (
+                            abspath,
+                            pathjoin,
+                            safe_unicode,
+                            sha_strings,
+                            sha_string,
+                            )
+from bzrlib.store.text import TextStore
+from bzrlib.store.weave import WeaveStore
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
-from bzrlib.symbol_versioning import *
+from bzrlib.transactions import PassThroughTransaction
 from bzrlib.transport import get_transport
 from bzrlib.transport.local import LocalTransport
+from bzrlib.weave import Weave
+from bzrlib.weavefile import read_weave, write_weave
+from bzrlib.xml4 import serializer_v4
+from bzrlib.xml5 import serializer_v5
 
 
 class BzrDir(object):
@@ -47,6 +61,10 @@
         a transport connected to the directory this bzr was opened from.
     """
 
+    def can_convert_format(self):
+        """Return true if this bzrdir is one whose format we can convert from."""
+        return True
+
     def _check_supported(self, format, allow_unsupported):
         """Check whether format is a supported format.
 
@@ -55,21 +73,42 @@
         if not allow_unsupported and not format.is_supported():
             raise errors.UnsupportedFormatError(format)
 
-    def clone(self, url, revision_id=None, basis=None):
+    def clone(self, url, revision_id=None, basis=None, force_new_repo=False):
         """Clone this bzrdir and its contents to url verbatim.
 
         If urls last component does not exist, it will be created.
 
         if revision_id is not None, then the clone operation may tune
             itself to download less data.
+        :param force_new_repo: Do not use a shared repository for the target 
+                               even if one is available.
         """
         self._make_tail(url)
+        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
         result = self._format.initialize(url)
-        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
         try:
-            self.open_repository().clone(result, revision_id=revision_id, basis=basis_repo)
+            local_repo = self.find_repository()
         except errors.NoRepositoryPresent:
-            pass
+            local_repo = None
+        if local_repo:
+            # may need to copy content in
+            if force_new_repo:
+                local_repo.clone(result, revision_id=revision_id, basis=basis_repo)
+            else:
+                try:
+                    result_repo = result.find_repository()
+                    # fetch content this dir needs.
+                    if basis_repo:
+                        # XXX FIXME RBC 20060214 need tests for this when the basis
+                        # is incomplete
+                        result_repo.fetch(basis_repo, revision_id=revision_id)
+                    result_repo.fetch(local_repo, revision_id=revision_id)
+                except errors.NoRepositoryPresent:
+                    # needed to make one anyway.
+                    local_repo.clone(result, revision_id=revision_id, basis=basis_repo)
+        # 1 if there is a branch present
+        #   make sure its content is available in the target repository
+        #   clone it.
         try:
             self.open_branch().clone(result, revision_id=revision_id)
         except errors.NotBranchError:
@@ -140,26 +179,72 @@
         raise NotImplementedError(self.create_branch)
 
     @staticmethod
-    def create_branch_and_repo(base):
+    def create_branch_and_repo(base, force_new_repo=False):
         """Create a new BzrDir, Branch and Repository at the url 'base'.
 
         This will use the current default BzrDirFormat, and use whatever 
         repository format that that uses via bzrdir.create_branch and
-        create_repository.
+        create_repository. If a shared repository is available that is used
+        preferentially.
 
         The created Branch object is returned.
+
+        :param base: The URL to create the branch at.
+        :param force_new_repo: If True a new repository is always created.
         """
         bzrdir = BzrDir.create(base)
-        bzrdir.create_repository()
+        bzrdir._find_or_create_repository(force_new_repo)
         return bzrdir.create_branch()
-        
-    @staticmethod
-    def create_repository(base):
+
+    def _find_or_create_repository(self, force_new_repo):
+        """Create a new repository if needed, returning the repository."""
+        if force_new_repo:
+            return self.create_repository()
+        try:
+            return self.find_repository()
+        except errors.NoRepositoryPresent:
+            return self.create_repository()
+        
+    @staticmethod
+    def create_branch_convenience(base, force_new_repo=False, force_new_tree=None):
+        """Create a new BzrDir, Branch and Repository at the url 'base'.
+
+        This is a convenience function - it will use an existing repository
+        if possible, can be told explicitly whether to create a working tree or
+        not.
+
+        This will use the current default BzrDirFormat, and use whatever 
+        repository format that that uses via bzrdir.create_branch and
+        create_repository. If a shared repository is available that is used
+        preferentially. Whatever repository is used, its tree creation policy
+        is followed.
+
+        The created Branch object is returned.
+        If a working tree cannot be made due to base not being a file:// url,
+        no error is raised.
+
+        :param base: The URL to create the branch at.
+        :param force_new_repo: If True a new repository is always created.
+        :param force_new_tree: If True or False force creation of a tree or 
+                               prevent such creation respectively.
+        """
+        bzrdir = BzrDir.create(base)
+        repo = bzrdir._find_or_create_repository(force_new_repo)
+        result = bzrdir.create_branch()
+        if force_new_tree or (repo.make_working_trees() and 
+                              force_new_tree is None):
+            bzrdir.create_workingtree()
+        return result
+        
+    @staticmethod
+    def create_repository(base, shared=False):
         """Create a new BzrDir and Repository at the url 'base'.
 
         This will use the current default BzrDirFormat, and use whatever 
         repository format that that uses for bzrdirformat.create_repository.
 
+        ;param shared: Create a shared repository rather than a standalone
+                       repository.
         The Repository object is returned.
 
         This must be overridden as an instance method in child classes, where
@@ -184,7 +269,8 @@
         t = get_transport(safe_unicode(base))
         if not isinstance(t, LocalTransport):
             raise errors.NotLocalUrl(base)
-        bzrdir = BzrDir.create_branch_and_repo(safe_unicode(base)).bzrdir
+        bzrdir = BzrDir.create_branch_and_repo(safe_unicode(base),
+                                               force_new_repo=True).bzrdir
         return bzrdir.create_workingtree()
 
     def create_workingtree(self, revision_id=None):
@@ -194,6 +280,36 @@
         """
         raise NotImplementedError(self.create_workingtree)
 
+    def find_repository(self):
+        """Find the repository that should be used for a_bzrdir.
+
+        This does not require a branch as we use it to find the repo for
+        new branches as well as to hook existing branches up to their
+        repository.
+        """
+        try:
+            return self.open_repository()
+        except errors.NoRepositoryPresent:
+            pass
+        next_transport = self.root_transport.clone('..')
+        while True:
+            try:
+                found_bzrdir = BzrDir.open_containing_from_transport(
+                    next_transport)[0]
+            except errors.NotBranchError:
+                raise errors.NoRepositoryPresent(self)
+            try:
+                repository = found_bzrdir.open_repository()
+            except errors.NoRepositoryPresent:
+                next_transport = found_bzrdir.root_transport.clone('..')
+                continue
+            if ((found_bzrdir.root_transport.base == 
+                 self.root_transport.base) or repository.is_shared()):
+                return repository
+            else:
+                raise errors.NoRepositoryPresent(self)
+        raise errors.NoRepositoryPresent(self)
+
     def get_branch_transport(self, branch_format):
         """Get the transport for use by branch format in this BzrDir.
 
@@ -246,6 +362,22 @@
         self.transport = _transport.clone('.bzr')
         self.root_transport = _transport
 
+    def needs_format_conversion(self, format=None):
+        """Return true if this bzrdir needs convert_format run on it.
+        
+        For instance, if the repository format is out of date but the 
+        branch and working tree are not, this should return True.
+
+        :param format: Optional parameter indicating a specific desired
+                       format we plan to arrive at.
+        """
+        # for now, if the format is not the same as the system default,
+        # an upgrade is needed. In the future we will want to scan
+        # the individual repository/branch/checkout formats too
+        if format is None:
+            format = BzrDirFormat.get_default_format().__class__
+        return not isinstance(self._format, format)
+
     @staticmethod
     def open_unsupported(base):
         """Open a branch which is not supported."""
@@ -283,7 +415,16 @@
     def open_containing(url):
         """Open an existing branch which contains url.
         
-        This probes for a branch at url, and searches upwards from there.
+        :param url: url to search from.
+        See open_containing_from_transport for more detail.
+        """
+        return BzrDir.open_containing_from_transport(get_transport(url))
+    
+    @staticmethod
+    def open_containing_from_transport(a_transport):
+        """Open an existing branch which contains a_transport.base
+
+        This probes for a branch at a_transport, and searches upwards from there.
 
         Basically we keep looking up until we find the control directory or
         run into the root.  If there isn't one, raises NotBranchError.
@@ -291,20 +432,19 @@
         format, UnknownFormatError or UnsupportedFormatError are raised.
         If there is one, it is returned, along with the unused portion of url.
         """
-        t = get_transport(url)
         # this gets the normalised url back. I.e. '.' -> the full path.
-        url = t.base
+        url = a_transport.base
         while True:
             try:
-                format = BzrDirFormat.find_format(t)
-                return format.open(t), t.relpath(url)
+                format = BzrDirFormat.find_format(a_transport)
+                return format.open(a_transport), a_transport.relpath(url)
             except errors.NotBranchError, e:
-                mutter('not a branch in: %r %s', t.base, e)
-            new_t = t.clone('..')
-            if new_t.base == t.base:
+                mutter('not a branch in: %r %s', a_transport.base, e)
+            new_t = a_transport.clone('..')
+            if new_t.base == a_transport.base:
                 # reached the root, whatever that may be
                 raise errors.NotBranchError(path=url)
-            t = new_t
+            a_transport = new_t
 
     def open_repository(self, _unsupported=False):
         """Open the repository object at this BzrDir if one is present.
@@ -325,7 +465,7 @@
         """
         raise NotImplementedError(self.open_workingtree)
 
-    def sprout(self, url, revision_id=None, basis=None):
+    def sprout(self, url, revision_id=None, basis=None, force_new_repo=False):
         """Create a copy of this bzrdir prepared for use as a new line of
         development.
 
@@ -350,15 +490,33 @@
             try:
                 source_repository = self.open_repository()
             except errors.NoRepositoryPresent:
-                # copy the basis one if there is one
+                # copy the entire basis one if there is one
+                # but there is no repository.
                 source_repository = basis_repo
-        if source_repository is not None:
+        if force_new_repo:
+            result_repo = None
+        else:
+            try:
+                result_repo = result.find_repository()
+            except errors.NoRepositoryPresent:
+                result_repo = None
+        if source_repository is None and result_repo is not None:
+            pass
+        elif source_repository is None and result_repo is None:
+            # no repo available, make a new one
+            result.create_repository()
+        elif source_repository is not None and result_repo is None:
+            # have soure, and want to make a new target repo
             source_repository.clone(result,
                                     revision_id=revision_id,
                                     basis=basis_repo)
         else:
-            # no repo available, make a new one
-            result.create_repository()
+            # fetch needed content into target.
+            if basis_repo:
+                # XXX FIXME RBC 20060214 need tests for this when the basis
+                # is incomplete
+                result_repo.fetch(basis_repo, revision_id=revision_id)
+            result_repo.fetch(source_repository, revision_id=revision_id)
         if source_branch is not None:
             source_branch.sprout(result, revision_id=revision_id)
         else:
@@ -375,7 +533,13 @@
 class BzrDirPreSplitOut(BzrDir):
     """A common class for the all-in-one formats."""
 
-    def clone(self, url, revision_id=None, basis=None):
+    def __init__(self, _transport, _format):
+        """See BzrDir.__init__."""
+        super(BzrDirPreSplitOut, self).__init__(_transport, _format)
+        self._control_files = LockableFiles(self.get_branch_transport(None),
+                                            'branch-lock')
+
+    def clone(self, url, revision_id=None, basis=None, force_new_repo=False):
         """See BzrDir.clone()."""
         from bzrlib.workingtree import WorkingTreeFormat2
         self._make_tail(url)
@@ -394,8 +558,10 @@
         """See BzrDir.create_branch."""
         return self.open_branch()
 
-    def create_repository(self):
+    def create_repository(self, shared=False):
         """See BzrDir.create_repository."""
+        if shared:
+            raise errors.IncompatibleFormat('shared repository', self._format)
         return self.open_repository()
 
     def create_workingtree(self, revision_id=None):
@@ -477,10 +643,14 @@
     This is a deprecated format and may be removed after sept 2006.
     """
 
-    def create_repository(self):
+    def create_repository(self, shared=False):
         """See BzrDir.create_repository."""
         from bzrlib.repository import RepositoryFormat4
-        return RepositoryFormat4().initialize(self)
+        return RepositoryFormat4().initialize(self, shared)
+
+    def needs_format_conversion(self, format=None):
+        """Format 4 dirs are always in need of conversion."""
+        return True
 
     def open_repository(self):
         """See BzrDir.open_repository."""
@@ -529,15 +699,19 @@
     individual formats are really split out.
     """
 
+    def can_convert_format(self):
+        """See BzrDir.can_convert_format()."""
+        return False
+
     def create_branch(self):
         """See BzrDir.create_branch."""
         from bzrlib.branch import BranchFormat
         return BranchFormat.get_default_format().initialize(self)
 
-    def create_repository(self):
+    def create_repository(self, shared=False):
         """See BzrDir.create_repository."""
         from bzrlib.repository import RepositoryFormat
-        return RepositoryFormat.get_default_format().initialize(self)
+        return RepositoryFormat.get_default_format().initialize(self, shared)
 
     def create_workingtree(self, revision_id=None):
         """See BzrDir.create_workingtree."""
@@ -586,6 +760,11 @@
             pass
         return self.transport.clone('checkout')
 
+    def needs_format_conversion(self, format=None):
+        """See BzrDir.needs_format_conversion()."""
+        # currently there are no possible conversions for meta1 formats.
+        return False
+
     def open_branch(self, unsupported=False):
         """See BzrDir.open_branch."""
         from bzrlib.branch import BranchFormat
@@ -651,6 +830,20 @@
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
 
+    def get_converter(self, format=None):
+        """Return the converter to use to convert bzrdirs needing converts.
+
+        This returns a bzrlib.bzrdir.Converter object.
+
+        This should return the best upgrader to step this format towards the
+        current default format. In the case of plugins we can/shouold provide
+        some means for them to extend the range of returnable converters.
+
+        :param format: Optional format to override the default foramt of the 
+                       library.
+        """
+        raise NotImplementedError(self.get_converter)
+
     def initialize(self, url):
         """Create a bzr control dir at this url and return an opened copy."""
         # Since we don't have a .bzr directory, inherit the
@@ -717,6 +910,9 @@
     def set_default_format(klass, format):
         klass._default_format = format
 
+    def __str__(self):
+        return self.get_format_string()[:-1]
+
     @classmethod
     def unregister_format(klass, format):
         assert klass._formats[format.get_format_string()] is format
@@ -740,6 +936,11 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 0.0.4\n"
 
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir4To5()
+        
     def initialize(self, url):
         """Format 4 branches cannot be created."""
         raise errors.UninitializableFormat(self)
@@ -773,6 +974,11 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 5\n"
 
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir5To6()
+        
     def initialize(self, url, _cloning=False):
         """Format 5 dirs always have working tree, branch and repository.
         
@@ -807,6 +1013,11 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 6\n"
 
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir6ToMeta()
+        
     def initialize(self, url, _cloning=False):
         """Format 6 dirs always have working tree, branch and repository.
         
@@ -953,3 +1164,405 @@
         copytree(self.base, base, symlinks=True)
         return ScratchDir(
             transport=bzrlib.transport.local.ScratchTransport(base))
+
+
+class Converter(object):
+    """Converts a disk format object from one format to another."""
+
+    def convert(self, to_convert, pb):
+        """Perform the conversion of to_convert, giving feedback via pb.
+
+        :param to_convert: The disk object to convert.
+        :param pb: a progress bar to use for progress information.
+        """
+
+
+class ConvertBzrDir4To5(Converter):
+    """Converts format 4 bzr dirs to format 5."""
+
+    def __init__(self):
+        super(ConvertBzrDir4To5, self).__init__()
+        self.converted_revs = set()
+        self.absent_revisions = set()
+        self.text_count = 0
+        self.revisions = {}
+        
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.pb.note('starting upgrade from format 4 to 5')
+        if isinstance(self.bzrdir.transport, LocalTransport):
+            self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
+        self._convert_to_weaves()
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def _convert_to_weaves(self):
+        self.pb.note('note: upgrade may be faster if all store files are ungzipped first')
+        try:
+            # TODO permissions
+            stat = self.bzrdir.transport.stat('weaves')
+            if not S_ISDIR(stat.st_mode):
+                self.bzrdir.transport.delete('weaves')
+                self.bzrdir.transport.mkdir('weaves')
+        except errors.NoSuchFile:
+            self.bzrdir.transport.mkdir('weaves')
+        self.inv_weave = Weave('inventory')
+        # holds in-memory weaves for all files
+        self.text_weaves = {}
+        self.bzrdir.transport.delete('branch-format')
+        self.branch = self.bzrdir.open_branch()
+        self._convert_working_inv()
+        rev_history = self.branch.revision_history()
+        # to_read is a stack holding the revisions we still need to process;
+        # appending to it adds new highest-priority revisions
+        self.known_revisions = set(rev_history)
+        self.to_read = rev_history[-1:]
+        while self.to_read:
+            rev_id = self.to_read.pop()
+            if (rev_id not in self.revisions
+                and rev_id not in self.absent_revisions):
+                self._load_one_rev(rev_id)
+        self.pb.clear()
+        to_import = self._make_order()
+        for i, rev_id in enumerate(to_import):
+            self.pb.update('converting revision', i, len(to_import))
+            self._convert_one_rev(rev_id)
+        self.pb.clear()
+        self._write_all_weaves()
+        self._write_all_revs()
+        self.pb.note('upgraded to weaves:')
+        self.pb.note('  %6d revisions and inventories', len(self.revisions))
+        self.pb.note('  %6d revisions not present', len(self.absent_revisions))
+        self.pb.note('  %6d texts', self.text_count)
+        self._cleanup_spare_files_after_format4()
+        self.branch.control_files.put_utf8('branch-format', BzrDirFormat5().get_format_string())
+
+    def _cleanup_spare_files_after_format4(self):
+        # FIXME working tree upgrade foo.
+        for n in 'merged-patches', 'pending-merged-patches':
+            try:
+                ## assert os.path.getsize(p) == 0
+                self.bzrdir.transport.delete(n)
+            except errors.NoSuchFile:
+                pass
+        self.bzrdir.transport.delete_tree('inventory-store')
+        self.bzrdir.transport.delete_tree('text-store')
+
+    def _convert_working_inv(self):
+        inv = serializer_v4.read_inventory(self.branch.control_files.get('inventory'))
+        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
+        # FIXME inventory is a working tree change.
+        self.branch.control_files.put('inventory', new_inv_xml)
+
+    def _write_all_weaves(self):
+        controlweaves = WeaveStore(self.bzrdir.transport, prefixed=False)
+        weave_transport = self.bzrdir.transport.clone('weaves')
+        weaves = WeaveStore(weave_transport, prefixed=False)
+        transaction = PassThroughTransaction()
+
+        controlweaves.put_weave('inventory', self.inv_weave, transaction)
+        i = 0
+        try:
+            for file_id, file_weave in self.text_weaves.items():
+                self.pb.update('writing weave', i, len(self.text_weaves))
+                weaves.put_weave(file_id, file_weave, transaction)
+                i += 1
+        finally:
+            self.pb.clear()
+
+    def _write_all_revs(self):
+        """Write all revisions out in new form."""
+        self.bzrdir.transport.delete_tree('revision-store')
+        self.bzrdir.transport.mkdir('revision-store')
+        revision_transport = self.bzrdir.transport.clone('revision-store')
+        # TODO permissions
+        revision_store = TextStore(revision_transport,
+                                   prefixed=False,
+                                   compressed=True)
+        try:
+            for i, rev_id in enumerate(self.converted_revs):
+                self.pb.update('write revision', i, len(self.converted_revs))
+                rev_tmp = StringIO()
+                serializer_v5.write_revision(self.revisions[rev_id], rev_tmp)
+                rev_tmp.seek(0)
+                revision_store.add(rev_tmp, rev_id)
+        finally:
+            self.pb.clear()
+            
+    def _load_one_rev(self, rev_id):
+        """Load a revision object into memory.
+
+        Any parents not either loaded or abandoned get queued to be
+        loaded."""
+        self.pb.update('loading revision',
+                       len(self.revisions),
+                       len(self.known_revisions))
+        if not self.branch.repository.revision_store.has_id(rev_id):
+            self.pb.clear()
+            self.pb.note('revision {%s} not present in branch; '
+                         'will be converted as a ghost',
+                         rev_id)
+            self.absent_revisions.add(rev_id)
+        else:
+            rev_xml = self.branch.repository.revision_store.get(rev_id).read()
+            rev = serializer_v4.read_revision_from_string(rev_xml)
+            for parent_id in rev.parent_ids:
+                self.known_revisions.add(parent_id)
+                self.to_read.append(parent_id)
+            self.revisions[rev_id] = rev
+
+    def _load_old_inventory(self, rev_id):
+        assert rev_id not in self.converted_revs
+        old_inv_xml = self.branch.repository.inventory_store.get(rev_id).read()
+        inv = serializer_v4.read_inventory_from_string(old_inv_xml)
+        rev = self.revisions[rev_id]
+        if rev.inventory_sha1:
+            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
+                'inventory sha mismatch for {%s}' % rev_id
+        return inv
+
+    def _load_updated_inventory(self, rev_id):
+        assert rev_id in self.converted_revs
+        inv_xml = self.inv_weave.get_text(rev_id)
+        inv = serializer_v5.read_inventory_from_string(inv_xml)
+        return inv
+
+    def _convert_one_rev(self, rev_id):
+        """Convert revision and all referenced objects to new format."""
+        rev = self.revisions[rev_id]
+        inv = self._load_old_inventory(rev_id)
+        present_parents = [p for p in rev.parent_ids
+                           if p not in self.absent_revisions]
+        self._convert_revision_contents(rev, inv, present_parents)
+        self._store_new_weave(rev, inv, present_parents)
+        self.converted_revs.add(rev_id)
+
+    def _store_new_weave(self, rev, inv, present_parents):
+        # the XML is now updated with text versions
+        if __debug__:
+            for file_id in inv:
+                ie = inv[file_id]
+                if ie.kind == 'root_directory':
+                    continue
+                assert hasattr(ie, 'revision'), \
+                    'no revision on {%s} in {%s}' % \
+                    (file_id, rev.revision_id)
+        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
+        new_inv_sha1 = sha_string(new_inv_xml)
+        self.inv_weave.add(rev.revision_id, 
+                           present_parents,
+                           new_inv_xml.splitlines(True),
+                           new_inv_sha1)
+        rev.inventory_sha1 = new_inv_sha1
+
+    def _convert_revision_contents(self, rev, inv, present_parents):
+        """Convert all the files within a revision.
+
+        Also upgrade the inventory to refer to the text revision ids."""
+        rev_id = rev.revision_id
+        mutter('converting texts of revision {%s}',
+               rev_id)
+        parent_invs = map(self._load_updated_inventory, present_parents)
+        for file_id in inv:
+            ie = inv[file_id]
+            self._convert_file_version(rev, ie, parent_invs)
+
+    def _convert_file_version(self, rev, ie, parent_invs):
+        """Convert one version of one file.
+
+        The file needs to be added into the weave if it is a merge
+        of >=2 parents or if it's changed from its parent.
+        """
+        if ie.kind == 'root_directory':
+            return
+        file_id = ie.file_id
+        rev_id = rev.revision_id
+        w = self.text_weaves.get(file_id)
+        if w is None:
+            w = Weave(file_id)
+            self.text_weaves[file_id] = w
+        text_changed = False
+        previous_entries = ie.find_previous_heads(parent_invs, w)
+        for old_revision in previous_entries:
+                # if this fails, its a ghost ?
+                assert old_revision in self.converted_revs 
+        self.snapshot_ie(previous_entries, ie, w, rev_id)
+        del ie.text_id
+        assert getattr(ie, 'revision', None) is not None
+
+    def snapshot_ie(self, previous_revisions, ie, w, rev_id):
+        # TODO: convert this logic, which is ~= snapshot to
+        # a call to:. This needs the path figured out. rather than a work_tree
+        # a v4 revision_tree can be given, or something that looks enough like
+        # one to give the file content to the entry if it needs it.
+        # and we need something that looks like a weave store for snapshot to 
+        # save against.
+        #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))
+        if len(previous_revisions) == 1:
+            previous_ie = previous_revisions.values()[0]
+            if ie._unchanged(previous_ie):
+                ie.revision = previous_ie.revision
+                return
+        parent_indexes = map(w.lookup, previous_revisions)
+        if ie.has_text():
+            text = self.branch.repository.text_store.get(ie.text_id)
+            file_lines = text.readlines()
+            assert sha_strings(file_lines) == ie.text_sha1
+            assert sum(map(len, file_lines)) == ie.text_size
+            w.add(rev_id, parent_indexes, file_lines, ie.text_sha1)
+            self.text_count += 1
+        else:
+            w.add(rev_id, parent_indexes, [], None)
+        ie.revision = rev_id
+
+    def _make_order(self):
+        """Return a suitable order for importing revisions.
+
+        The order must be such that an revision is imported after all
+        its (present) parents.
+        """
+        todo = set(self.revisions.keys())
+        done = self.absent_revisions.copy()
+        order = []
+        while todo:
+            # scan through looking for a revision whose parents
+            # are all done
+            for rev_id in sorted(list(todo)):
+                rev = self.revisions[rev_id]
+                parent_ids = set(rev.parent_ids)
+                if parent_ids.issubset(done):
+                    # can take this one now
+                    order.append(rev_id)
+                    todo.remove(rev_id)
+                    done.add(rev_id)
+        return order
+
+
+class ConvertBzrDir5To6(Converter):
+    """Converts format 5 bzr dirs to format 6."""
+
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.pb.note('starting upgrade from format 5 to 6')
+        self._convert_to_prefixed()
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def _convert_to_prefixed(self):
+        from bzrlib.store import hash_prefix
+        self.bzrdir.transport.delete('branch-format')
+        for store_name in ["weaves", "revision-store"]:
+            self.pb.note("adding prefixes to %s" % store_name) 
+            store_transport = self.bzrdir.transport.clone(store_name)
+            for filename in store_transport.list_dir('.'):
+                if (filename.endswith(".weave") or
+                    filename.endswith(".gz") or
+                    filename.endswith(".sig")):
+                    file_id = os.path.splitext(filename)[0]
+                else:
+                    file_id = filename
+                prefix_dir = hash_prefix(file_id)
+                # FIXME keep track of the dirs made RBC 20060121
+                try:
+                    store_transport.move(filename, prefix_dir + '/' + filename)
+                except errors.NoSuchFile: # catches missing dirs strangely enough
+                    store_transport.mkdir(prefix_dir)
+                    store_transport.move(filename, prefix_dir + '/' + filename)
+        self.bzrdir._control_files.put_utf8('branch-format', BzrDirFormat6().get_format_string())
+
+
+class ConvertBzrDir6ToMeta(Converter):
+    """Converts format 6 bzr dirs to metadirs."""
+
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.count = 0
+        self.total = 20 # the steps we know about
+        self.garbage_inventories = []
+
+        self.pb.note('starting upgrade from format 6 to metadir')
+        self.bzrdir._control_files.put_utf8('branch-format', "Converting to format 6")
+        # its faster to move specific files around than to open and use the apis...
+        # first off, nuke ancestry.weave, it was never used.
+        try:
+            self.step('Removing ancestry.weave')
+            self.bzrdir.transport.delete('ancestry.weave')
+        except errors.NoSuchFile:
+            pass
+        # find out whats there
+        self.step('Finding branch files')
+        last_revision = self.bzrdir.open_workingtree().last_revision()
+        bzrcontents = self.bzrdir.transport.list_dir('.')
+        for name in bzrcontents:
+            if name.startswith('basis-inventory.'):
+                self.garbage_inventories.append(name)
+        # create new directories for repository, working tree and branch
+        dir_mode = self.bzrdir._control_files._dir_mode
+        self.file_mode = self.bzrdir._control_files._file_mode
+        repository_names = [('inventory.weave', True),
+                            ('revision-store', True),
+                            ('weaves', True)]
+        self.step('Upgrading repository  ')
+        self.bzrdir.transport.mkdir('repository', mode=dir_mode)
+        self.make_lock('repository')
+        # we hard code the formats here because we are converting into
+        # the meta format. The meta format upgrader can take this to a 
+        # future format within each component.
+        self.put_format('repository', bzrlib.repository.RepositoryFormat7())
+        for entry in repository_names:
+            self.move_entry('repository', entry)
+
+        self.step('Upgrading branch      ')
+        self.bzrdir.transport.mkdir('branch', mode=dir_mode)
+        self.make_lock('branch')
+        self.put_format('branch', bzrlib.branch.BzrBranchFormat5())
+        branch_files = [('revision-history', True),
+                        ('branch-name', True),
+                        ('parent', False)]
+        for entry in branch_files:
+            self.move_entry('branch', entry)
+
+        self.step('Upgrading working tree')
+        self.bzrdir.transport.mkdir('checkout', mode=dir_mode)
+        self.make_lock('checkout')
+        self.put_format('checkout', bzrlib.workingtree.WorkingTreeFormat3())
+        self.bzrdir.transport.delete_multi(self.garbage_inventories, self.pb)
+        checkout_files = [('pending-merges', True),
+                          ('inventory', True),
+                          ('stat-cache', False)]
+        for entry in checkout_files:
+            self.move_entry('checkout', entry)
+        if last_revision is not None:
+            self.bzrdir._control_files.put_utf8('checkout/last-revision',
+                                                last_revision)
+        self.bzrdir._control_files.put_utf8('branch-format', BzrDirMetaFormat1().get_format_string())
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def make_lock(self, name):
+        """Make a lock for the new control dir name."""
+        self.step('Make %s lock' % name)
+        self.bzrdir.transport.put('%s/lock' % name, StringIO(), mode=self.file_mode)
+
+    def move_entry(self, new_dir, entry):
+        """Move then entry name into new_dir."""
+        name = entry[0]
+        mandatory = entry[1]
+        self.step('Moving %s' % name)
+        try:
+            self.bzrdir.transport.move(name, '%s/%s' % (new_dir, name))
+        except errors.NoSuchFile:
+            if mandatory:
+                raise
+
+    def put_format(self, dirname, format):
+        self.bzrdir._control_files.put_utf8('%s/format' % dirname, format.get_format_string())
+
+    def step(self, message):
+        """Update the pb by a step."""
+        self.count +=1
+        self.pb.update('Upgrading repository  ', self.count, self.total)
+

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2006-02-13 01:28:03 +0000
+++ bzrlib/commands.py	2006-02-21 01:05:33 +0000
@@ -42,7 +42,6 @@
                            BzrOptionError,
                            NotBranchError)
 from bzrlib.revisionspec import RevisionSpec
-from bzrlib import BZRDIR
 from bzrlib.option import Option
 
 plugin_cmds = {}

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2006-02-14 17:19:40 +0000
+++ bzrlib/errors.py	2006-02-21 01:05:33 +0000
@@ -293,6 +293,15 @@
 class UpgradeReadonly(BzrNewError):
     """Upgrade URL cannot work with readonly URL's."""
 
+
+class UpToDateFormat(BzrNewError):
+    """The branch format %(format)s is already at the most recent format."""
+
+    def __init__(self, format):
+        BzrNewError.__init__(self)
+        self.format = format
+
+
 class StrictCommitFailed(Exception):
     """Commit refused because there are unknowns in the tree."""
 

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2006-02-14 17:19:40 +0000
+++ bzrlib/fetch.py	2006-02-21 01:05:33 +0000
@@ -80,9 +80,10 @@
     """
     def __init__(self, to_repository, from_repository, last_revision=None, pb=None):
         if to_repository.bzrdir.transport.base == from_repository.bzrdir.transport.base:
-            raise Exception("can't fetch from a repository to itself %s, %s" % 
-                            (from_repository.bzrdir.transport.base,
-                             to_repository.bzrdir.transport.base))
+            # check that last_revision is in 'from' and then return a no-operation.
+            if last_revision not in (None, NULL_REVISION):
+                from_repository.get_revision(last_revision)
+            return
         self.to_repository = to_repository
         self.from_repository = from_repository
         # must not mutate self._last_revision as its potentially a shared instance

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2006-02-11 11:58:06 +0000
+++ bzrlib/info.py	2006-02-15 06:08:08 +0000
@@ -16,10 +16,14 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+__all__ = ['show_bzrdir_info']
+
 import time
 
+
+import bzrlib.diff as diff
 from bzrlib.osutils import format_date
-from bzrlib.workingtree import WorkingTree
+from bzrlib.symbol_versioning import *
 
 
 def _countiter(it):
@@ -30,12 +34,26 @@
     return i        
 
 
-
+@deprecated_function(zero_eight)
 def show_info(b):
-    import diff
+    """Please see show_bzrdir_info."""
+    return show_bzrdir_info(b.bzrdir)
+
+def show_bzrdir_info(a_bzrdir):
+    """Output to stdout the 'info' for a_bzrdir."""
+
+    working = a_bzrdir.open_workingtree()
+    b = a_bzrdir.open_branch()
     
-    print 'branch format:', b.control_files.get_utf8(
-        'branch-format').readline().rstrip('\n')
+    if working.bzrdir != b.bzrdir:
+        print 'working tree format:', working._format
+        print 'branch location:', b.bzrdir.root_transport.base
+    try:
+        b._format.get_format_string()
+        format = b._format
+    except NotImplementedError:
+        format = b.bzrdir._format
+    print 'branch format:', format
 
     def plural(n, base='', pl=None):
         if n == 1:
@@ -47,12 +65,20 @@
 
     count_version_dirs = 0
 
-    working = b.bzrdir.open_workingtree()
     basis = working.basis_tree()
     work_inv = working.inventory
     delta = diff.compare_trees(basis, working, want_unchanged=True)
+    history = b.revision_history()
     
     print
+    if len(history) and working.last_revision() != history[-1]:
+        try:
+            missing_count = len(history) - history.index(working.last_revision())
+        except ValueError:
+            # consider it all out of date
+            missing_count = len(history)
+        print 'Working tree is out of date: missing %d revision%s.' % (
+            missing_count, plural(missing_count))
     print 'in the working tree:'
     print '  %8s unchanged' % len(delta.unchanged)
     print '  %8d modified' % len(delta.modified)
@@ -80,7 +106,6 @@
 
     print
     print 'branch history:'
-    history = b.revision_history()
     revno = len(history)
     print '  %8d revision%s' % (revno, plural(revno))
     committers = {}
@@ -107,7 +132,7 @@
     print
     print 'revision store:'
     c, t = b.repository.revision_store.total_size()
-    print '  %8d revisions' % c
+    print '  %8d revision%s' % (c, plural(c))
     print '  %8d kB' % (t/1024)
 
 

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-12-25 00:38:48 +0000
+++ bzrlib/missing.py	2006-02-16 21:29:34 +0000
@@ -1,7 +1,8 @@
-"""\
-A plugin for displaying what revisions are in 'other' but not in local.
-"""
-from bzrlib.ui import ui_factory
+"""Display what revisions are missing in 'other' from 'this' and vice verca."""
+
+import bzrlib.ui as ui
+
+
 def iter_log_data(revisions, revision_source, verbose):
     from bzrlib.diff import compare_trees
     from bzrlib.tree import EmptyTree
@@ -26,7 +27,7 @@
 
 
 def find_unmerged(local_branch, remote_branch):
-    progress = ui_factory.progress_bar()
+    progress = ui.ui_factory.progress_bar()
     local_branch.lock_read()
     try:
         remote_branch.lock_read()

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2005-11-29 01:20:57 +0000
+++ bzrlib/progress.py	2006-02-16 08:18:32 +0000
@@ -69,10 +69,11 @@
                  show_spinner=False,
                  show_eta=True,
                  show_bar=True,
-                 show_count=True):
+                 show_count=True,
+                 to_messages_file=sys.stdout):
         object.__init__(self)
         self.to_file = to_file
- 
+        self.to_messages_file = to_messages_file
         self.last_msg = None
         self.last_cnt = None
         self.last_total = None
@@ -82,6 +83,11 @@
         self.show_bar = show_bar
         self.show_count = show_count
 
+    def note(self, fmt_string, *args, **kwargs):
+        """Record a note without disrupting the progress bar."""
+        self.clear()
+        self.to_messages_file.write(fmt_string % args)
+        self.to_messages_file.write('\n')
 
 
 class DummyProgress(_BaseProgressBar):
@@ -98,7 +104,10 @@
     def clear(self):
         pass
         
-    
+    def note(self, fmt_string, *args, **kwargs):
+        """See _BaseProgressBar.note()."""
+
+
 class DotsProgressBar(_BaseProgressBar):
     def __init__(self, **kwargs):
         _BaseProgressBar.__init__(self, **kwargs)
@@ -255,11 +264,9 @@
         self.to_file.write('\r' + m.ljust(self.width - 1))
         #self.to_file.flush()
             
-
     def clear(self):        
         self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
         #self.to_file.flush()        
-    
 
         
 def str_tdelta(delt):

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2006-02-17 02:01:02 +0000
+++ bzrlib/repository.py	2006-02-18 00:57:17 +0000
@@ -84,18 +84,16 @@
         """Construct the current default format repository in a_bzrdir."""
         return RepositoryFormat.get_default_format().initialize(a_bzrdir)
 
-    def __init__(self, transport, branch_format, _format=None, a_bzrdir=None):
+    def __init__(self, _format, a_bzrdir):
         object.__init__(self)
-        if transport is not None:
-            warn("Repository.__init__(..., transport=XXX): The transport parameter is "
-                 "deprecated and was never in a supported release. Please use "
-                 "bzrdir.open_repository() or bzrdir.open_branch().repository.",
-                 DeprecationWarning,
-                 stacklevel=2)
-            self.control_files = LockableFiles(transport.clone(bzrlib.BZRDIR), 'README')
-        else: 
-            # TODO: clone into repository if needed
-            self.control_files = LockableFiles(a_bzrdir.get_repository_transport(None), 'README')
+        if isinstance(_format, (RepositoryFormat4,
+                                RepositoryFormat5,
+                                RepositoryFormat6)):
+            # legacy: use a common control files.
+            self.control_files = a_bzrdir._control_files
+        else:
+            self.control_files = LockableFiles(a_bzrdir.get_repository_transport(None),
+                                               'lock')
 
         dir_mode = self.control_files._dir_mode
         file_mode = self.control_files._file_mode
@@ -116,7 +114,6 @@
                 ws.enable_cache = True
             return ws
 
-
         def get_store(name, compressed=True, prefixed=False):
             # FIXME: This approach of assuming stores are all entirely compressed
             # or entirely uncompressed is tidy, but breaks upgrade from 
@@ -137,20 +134,6 @@
             #    store = bzrlib.store.CachedStore(store, cache_path)
             return store
 
-        if branch_format is not None:
-            # circular dependencies:
-            from bzrlib.branch import (BzrBranchFormat4,
-                                       BzrBranchFormat5,
-                                       BzrBranchFormat6,
-                                       )
-            if isinstance(branch_format, BzrBranchFormat4):
-                self._format = RepositoryFormat4()
-            elif isinstance(branch_format, BzrBranchFormat5):
-                self._format = RepositoryFormat5()
-            elif isinstance(branch_format, BzrBranchFormat6):
-                self._format = RepositoryFormat6()
-            
-
         if isinstance(self._format, RepositoryFormat4):
             self.inventory_store = get_store('inventory-store')
             self.text_store = get_store('text-store')
@@ -254,9 +237,17 @@
 
     @needs_read_lock
     def copy_content_into(self, destination, revision_id=None, basis=None):
-        """Make a complete copy of the content in self into destination."""
+        """Make a complete copy of the content in self into destination.
+        
+        This is a destructive operation! Do not use it on existing 
+        repositories.
+        """
         destination.lock_write()
         try:
+            try:
+                destination.set_make_working_trees(self.make_working_trees())
+            except NotImplementedError:
+                pass
             # optimised paths:
             # compatible stores
             if self._compatible_formats(destination):
@@ -326,7 +317,7 @@
                        bzrdir.BzrDirFormat6)):
             result = a_bzrdir.open_repository()
         else:
-            result = self._format.initialize(a_bzrdir)
+            result = self._format.initialize(a_bzrdir, shared=self.is_shared())
         self.copy_content_into(result, revision_id, basis)
         return result
 
@@ -518,6 +509,12 @@
             return self.get_inventory(revision_id)
 
     @needs_read_lock
+    def is_shared(self):
+        """Return True if this repository is flagged as a shared repository."""
+        # FIXME format 4-6 cannot be shared, this is technically faulty.
+        return self.control_files._transport.has('shared-storage')
+
+    @needs_read_lock
     def revision_tree(self, revision_id):
         """Return Tree for a revision on this branch.
 
@@ -574,6 +571,38 @@
         return self.control_files.get_transaction()
 
     @needs_write_lock
+    def set_make_working_trees(self, new_value):
+        """Set the policy flag for making working trees when creating branches.
+
+        This only applies to branches that use this repository.
+
+        The default is 'True'.
+        :param new_value: True to restore the default, False to disable making
+                          working trees.
+        """
+        # FIXME: split out into a new class/strategy ?
+        if isinstance(self._format, (RepositoryFormat4,
+                                     RepositoryFormat5,
+                                     RepositoryFormat6)):
+            raise NotImplementedError(self.set_make_working_trees)
+        if new_value:
+            try:
+                self.control_files._transport.delete('no-working-trees')
+            except errors.NoSuchFile:
+                pass
+        else:
+            self.control_files.put_utf8('no-working-trees', '')
+    
+    def make_working_trees(self):
+        """Returns the policy for making working trees on new branches."""
+        # FIXME: split out into a new class/strategy ?
+        if isinstance(self._format, (RepositoryFormat4,
+                                     RepositoryFormat5,
+                                     RepositoryFormat6)):
+            return True
+        return not self.control_files._transport.has('no-working-trees')
+
+    @needs_write_lock
     def sign_revision(self, revision_id, gpg_strategy):
         plaintext = Testament.from_revision(self, revision_id).as_short_text()
         self.store_revision_signature(gpg_strategy, plaintext, revision_id)
@@ -634,42 +663,15 @@
         """
         raise NotImplementedError(self.get_format_string)
 
-    def initialize(self, a_bzrdir, _internal=False):
-        """Create a weave repository.
-        
-        TODO: when creating split out bzr branch formats, move this to a common
-        base for Format5, Format6. or something like that.
+    def initialize(self, a_bzrdir, shared=False):
+        """Initialize a repository of this format in a_bzrdir.
+
+        :param a_bzrdir: The bzrdir to put the new repository in it.
+        :param shared: The repository should be initialized as a sharable one.
+
+        This may raise UninitializableFormat if shared repository are not
+        compatible the a_bzrdir.
         """
-        from bzrlib.weavefile import write_weave_v5
-        from bzrlib.weave import Weave
-
-        if not _internal:
-            # always initialized when the bzrdir is.
-            return Repository(None, branch_format=None, _format=self, a_bzrdir=a_bzrdir)
-        
-        # Create an empty weave
-        sio = StringIO()
-        bzrlib.weavefile.write_weave_v5(Weave(), sio)
-        empty_weave = sio.getvalue()
-
-        mutter('creating repository in %s.', a_bzrdir.transport.base)
-        dirs = ['revision-store', 'weaves']
-        lock_file = 'branch-lock'
-        files = [('inventory.weave', StringIO(empty_weave)), 
-                 ]
-        
-        # FIXME: RBC 20060125 dont peek under the covers
-        # NB: no need to escape relative paths that are url safe.
-        control_files = LockableFiles(a_bzrdir.transport, 'branch-lock')
-        control_files.lock_write()
-        control_files._transport.mkdir_multi(dirs,
-                mode=control_files._dir_mode)
-        try:
-            for file, content in files:
-                control_files.put(file, content)
-        finally:
-            control_files.unlock()
-        return Repository(None, branch_format=None, _format=self, a_bzrdir=a_bzrdir)
 
     def is_supported(self):
         """Is this format supported?
@@ -688,7 +690,7 @@
         if not _found:
             # we are being called directly and must probe.
             raise NotImplementedError
-        return Repository(None, branch_format=None, _format=self, a_bzrdir=a_bzrdir)
+        return Repository(_format=self, a_bzrdir=a_bzrdir)
 
     @classmethod
     def register_format(klass, format):
@@ -704,7 +706,51 @@
         del klass._formats[format.get_format_string()]
 
 
-class RepositoryFormat4(RepositoryFormat):
+class PreSplitOutRepositoryFormat(RepositoryFormat):
+    """Base class for the pre split out repository formats."""
+
+    def initialize(self, a_bzrdir, shared=False, _internal=False):
+        """Create a weave repository.
+        
+        TODO: when creating split out bzr branch formats, move this to a common
+        base for Format5, Format6. or something like that.
+        """
+        from bzrlib.weavefile import write_weave_v5
+        from bzrlib.weave import Weave
+
+        if shared:
+            raise errors.IncompatibleFormat(self, a_bzrdir._format)
+
+        if not _internal:
+            # always initialized when the bzrdir is.
+            return Repository(_format=self, a_bzrdir=a_bzrdir)
+        
+        # Create an empty weave
+        sio = StringIO()
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
+        empty_weave = sio.getvalue()
+
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
+        dirs = ['revision-store', 'weaves']
+        lock_file = 'branch-lock'
+        files = [('inventory.weave', StringIO(empty_weave)), 
+                 ]
+        
+        # FIXME: RBC 20060125 dont peek under the covers
+        # NB: no need to escape relative paths that are url safe.
+        control_files = LockableFiles(a_bzrdir.transport, 'branch-lock')
+        control_files.lock_write()
+        control_files._transport.mkdir_multi(dirs,
+                mode=control_files._dir_mode)
+        try:
+            for file, content in files:
+                control_files.put(file, content)
+        finally:
+            control_files.unlock()
+        return Repository(_format=self, a_bzrdir=a_bzrdir)
+
+
+class RepositoryFormat4(PreSplitOutRepositoryFormat):
     """Bzr repository format 4.
 
     This repository format has:
@@ -720,7 +766,7 @@
         super(RepositoryFormat4, self).__init__()
         self._matchingbzrdir = bzrdir.BzrDirFormat4()
 
-    def initialize(self, url, _internal=False):
+    def initialize(self, url, shared=False, _internal=False):
         """Format 4 branches cannot be created."""
         raise errors.UninitializableFormat(self)
 
@@ -734,7 +780,7 @@
         return False
 
 
-class RepositoryFormat5(RepositoryFormat):
+class RepositoryFormat5(PreSplitOutRepositoryFormat):
     """Bzr control format 5.
 
     This repository format has:
@@ -748,7 +794,7 @@
         self._matchingbzrdir = bzrdir.BzrDirFormat5()
 
 
-class RepositoryFormat6(RepositoryFormat):
+class RepositoryFormat6(PreSplitOutRepositoryFormat):
     """Bzr control format 6.
 
     This repository format has:
@@ -770,14 +816,18 @@
      - hash subdirectory based stores.
      - TextStores for revisions and signatures.
      - a format marker of its own
+     - an optional 'shared-storage' flag
     """
 
     def get_format_string(self):
         """See RepositoryFormat.get_format_string()."""
         return "Bazaar-NG Repository format 7"
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, shared=False):
         """Create a weave repository.
+
+        :param shared: If true the repository will be initialized as a shared
+                       repository.
         """
         from bzrlib.weavefile import write_weave_v5
         from bzrlib.weave import Weave
@@ -807,9 +857,11 @@
                 control_files.put(file, content)
             for file, content in utf8_files:
                 control_files.put_utf8(file, content)
+            if shared == True:
+                control_files.put_utf8('shared-storage', '')
         finally:
             control_files.unlock()
-        return Repository(None, branch_format=None, _format=self, a_bzrdir=a_bzrdir)
+        return Repository(_format=self, a_bzrdir=a_bzrdir)
 
     def __init__(self):
         super(RepositoryFormat7, self).__init__()
@@ -826,10 +878,6 @@
                    RepositoryFormat6()]
 
 
-# TODO: jam 20060108 Create a new branch format, and as part of upgrade
-#       make sure that ancestry.weave is deleted (it is never used, but
-#       used to be created)
-
 class RepositoryTestProviderAdapter(object):
     """A tool to generate a suite testing multiple repository formats at once.
 

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2006-02-14 17:19:40 +0000
+++ bzrlib/tests/__init__.py	2006-02-21 01:05:33 +0000
@@ -747,10 +747,10 @@
         except errors.UninitializableFormat:
             raise TestSkipped("Format %s is not initializable.")
 
-    def make_repository(self, relpath):
+    def make_repository(self, relpath, shared=False):
         """Create a repository on our default transport at relpath."""
         made_control = self.make_bzrdir(relpath)
-        return made_control.create_repository()
+        return made_control.create_repository(shared=shared)
 
     def make_branch_and_tree(self, relpath):
         """Create a branch on the transport and a tree locally.

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2006-02-17 13:57:25 +0000
+++ bzrlib/tests/blackbox/__init__.py	2006-02-21 01:05:33 +0000
@@ -41,6 +41,7 @@
                      'bzrlib.tests.blackbox.test_export',
                      'bzrlib.tests.blackbox.test_find_merge_base',
                      'bzrlib.tests.blackbox.test_help',
+                     'bzrlib.tests.blackbox.test_info',
                      'bzrlib.tests.blackbox.test_log',
                      'bzrlib.tests.blackbox.test_logformats',
                      'bzrlib.tests.blackbox.test_missing',

=== added file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_info.py	2006-02-15 06:08:08 +0000
@@ -0,0 +1,169 @@
+# Copyright (C) 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for the info command of bzr."""
+
+
+from bzrlib.osutils import format_date
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestInfo(ExternalBase):
+
+    def test_info_standalone_trivial(self):
+        self.runbzr("init")
+        out, err = self.runbzr('info')
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG branch, format 6
+
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""",
+        out)
+        self.assertEqual('', err)
+
+    def test_info_up_to_date_checkout(self):
+        a_branch = self.make_branch_and_tree('branch')
+        self.runbzr('checkout branch checkout')
+        out, err = self.runbzr('info checkout')
+        self.assertEqualDiff(
+"""working tree format: Bazaar-NG Working Tree format 3
+branch location: %s
+branch format: Bazaar-NG branch, format 6
+
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % a_branch.bzrdir.root_transport.base,
+        out)
+        self.assertEqual('', err)
+
+    def test_info_out_of_date_standalone_tree(self):
+        # FIXME the default format has to change for this to pass
+        # because it currently uses the branch last-revision marker.
+        raise TestSkipped('default format too old')
+        self.make_branch_and_tree('branch')
+        # make a checkout
+        self.runbzr('checkout branch checkout')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now branch should be out of date
+        out,err = self.runbzr('update branch')
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG branch, format 6
+
+Working tree is out of date: missing 1 revision.
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % a_branch.bzrdir.root_transport.base,
+        out)
+        self.assertEqual('', err)
+
+    def test_info_out_of_date_checkout(self):
+        # note this deliberately uses a checkout at 'None' to 
+        # test the out of date message with a revision notin the 
+        # revision history.
+        a_branch = self.make_branch('branch')
+        # make two checkouts
+        self.runbzr('checkout branch checkout')
+        self.runbzr('checkout branch checkout2')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now checkout2 should be out of date
+        out,err = self.runbzr('info checkout2')
+        rev = a_branch.repository.get_revision(a_branch.revision_history()[0])
+        datestring = format_date(rev.timestamp, rev.timezone)
+        self.assertEqualDiff(
+"""working tree format: Bazaar-NG Working Tree format 3
+branch location: %s
+branch format: Bazaar-NG branch, format 6
+
+Working tree is out of date: missing 1 revision.
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         1 revision
+         1 committer
+         0 days old
+   first revision: %s
+  latest revision: %s
+
+revision store:
+         1 revision
+         0 kB
+""" % (a_branch.bzrdir.root_transport.base,
+       datestring,
+       datestring,
+       ),
+            out)
+        self.assertEqual('', err)

=== modified file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	2006-02-14 17:23:26 +0000
+++ bzrlib/tests/blackbox/test_update.py	2006-02-21 01:05:33 +0000
@@ -34,7 +34,7 @@
     def test_update_up_to_date_checkout(self):
         self.make_branch_and_tree('branch')
         self.runbzr('checkout branch checkout')
-        out, err = self.runbzr('update branch')
+        out, err = self.runbzr('update checkout')
         self.assertEqual('Tree is up to date.\n', err)
         self.assertEqual('', out)
 

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2006-02-01 11:50:27 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2006-02-16 11:19:47 +0000
@@ -23,20 +23,109 @@
 import bzrlib.bzrdir as bzrdir
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.transport import get_transport
-
-
-class TestUpgrade(TestCaseWithTransport):
+import bzrlib.ui as ui
+
+
+class TestUIFactory(ui.UIFactory):
+    """A UI Factory which never captures its output.
+    """
+
+    def note(self, fmt_string, *args, **kwargs):
+        """See progress.ProgressBar.note()."""
+        print fmt_string % args
+
+    def progress_bar(self):
+        return self
+        
+    def update(self, message, count, total):
+        """See progress.ProgressBar.update()."""
+
+
+class TestWithUpgradableBranches(TestCaseWithTransport):
 
     def setUp(self):
-        super(TestUpgrade, self).setUp()
+        super(TestWithUpgradableBranches, self).setUp()
+        self.old_format = bzrdir.BzrDirFormat.get_default_format()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+
+        ui.ui_factory = TestUIFactory()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
         # FIXME RBC 20060120 we should be able to do this via ui calls only.
         # setup a format 5 branch we can upgrade from.
         t = get_transport(self.get_url())
-        t.mkdir('old_branch')
-        bzrdir.BzrDirFormat5().initialize(self.get_url('old_branch'))
+        t.mkdir('format_5_branch')
+        bzrdir.BzrDirFormat5().initialize(self.get_url('format_5_branch'))
+        bzrdir.BzrDir.create_standalone_workingtree('current_format_branch')
+        self.run_bzr('checkout',
+                     self.get_url('current_format_branch'),
+                     'current_format_checkout')
+
+    def restoreDefaults(self):
+        bzrdir.BzrDirFormat.set_default_format(self.old_format)
+        ui.ui_factory = self.old_ui_factory
 
     def test_readonly_url_error(self):
         (out, err) = self.run_bzr_captured(
-            ['upgrade', self.get_readonly_url('old_branch')], 3)
+            ['upgrade', self.get_readonly_url('format_5_branch')], 3)
         self.assertEqual(out, "")
         self.assertEqual(err, "bzr: ERROR: Upgrade URL cannot work with readonly URL's.\n")
+
+    def test_upgrade_up_to_date(self):
+        # when up to date we should get a message to that effect
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', 'current_format_branch'], 3)
+        self.assertEqual("", out)
+        self.assertEqualDiff("bzr: ERROR: The branch format Bazaar-NG meta "
+                             "directory, format 1 is already at the most "
+                             "recent format.\n", err)
+
+    def test_upgrade_up_to_date_checkout_warns_branch_left_alone(self):
+        # when upgrading a checkout, the branch location and a suggestion
+        # to upgrade it should be emitted even if the checkout is up to 
+        # date
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', 'current_format_checkout'], 3)
+        self.assertEqual("This is a checkout. The branch (%s) needs to be "
+                         "upgraded separately.\n" 
+                         % get_transport(self.get_url('current_format_branch')).base,
+                         out)
+        self.assertEqualDiff("bzr: ERROR: The branch format Bazaar-NG meta "
+                             "directory, format 1 is already at the most "
+                             "recent format.\n", err)
+
+    def test_upgrade_checkout(self):
+        # upgrading a checkout should work
+        pass
+
+    def test_upgrade_repository_scans_branches(self):
+        # we should get individual upgrade notes for each branch even the 
+        # anonymous branch
+        pass
+
+    def test_ugrade_branch_in_repo(self):
+        # upgrading a branch in a repo should warn about not upgrading the repo
+        pass
+
+    def test_upgrade_explicit_metaformat(self):
+        # users can force an upgrade to metadir format.
+        url = get_transport(self.get_url('format_5_branch')).base
+        # check --format takes effect
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirFormat5())
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', '--format=metadir', url])
+        self.assertEqualDiff("""starting upgrade of %s
+making backup of tree history
+%s.bzr has been backed up to %s.bzr.backup
+if conversion fails, you can move this directory back to .bzr
+if it succeeds, you can remove this directory if you wish
+starting upgrade from format 5 to 6
+adding prefixes to weaves
+adding prefixes to revision-store
+starting upgrade from format 6 to metadir
+finished
+""" % (url, url, url), out)
+        self.assertEqualDiff("", err)
+        self.assertTrue(isinstance(
+            bzrdir.BzrDir.open(self.get_url('format_5_branch'))._format,
+            bzrdir.BzrDirMetaFormat1))

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2006-02-13 21:52:05 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2006-02-16 07:20:25 +0000
@@ -41,6 +41,7 @@
 from bzrlib.upgrade import upgrade
 from bzrlib.workingtree import WorkingTree
 
+
 # TODO: Make a branch using basis branch, and check that it 
 # doesn't request any files that could have been avoided, by 
 # hooking into the Transport.
@@ -66,7 +67,7 @@
         except errors.UninitializableFormat:
             raise TestSkipped('Uninitializable branch format')
 
-    def make_repository(self, relpath):
+    def make_repository(self, relpath, shared=False):
         try:
             url = self.get_url(relpath)
             segments = url.split('/')
@@ -78,7 +79,7 @@
                 except FileExists:
                     pass
             made_control = self.bzrdir_format.initialize(url)
-            return made_control.create_repository()
+            return made_control.create_repository(shared=shared)
         except UninitializableFormat:
             raise TestSkipped("Format %s is not initializable.")
 
@@ -271,14 +272,17 @@
                             'sig').read())
 
     def test_upgrade_preserves_signatures(self):
-        # this is in the current test format
         wt = self.make_branch_and_tree('source')
         wt.commit('A', allow_pointless=True, rev_id='A')
         wt.branch.repository.sign_revision('A',
             bzrlib.gpg.LoopbackGPGStrategy(None))
         old_signature = wt.branch.repository.revision_store.get('A',
             'sig').read()
-        upgrade(wt.basedir)
+        try:
+            upgrade(wt.basedir)
+        except errors.UpToDateFormat:
+            # this is in the most current format already.
+            return
         wt = WorkingTree.open(wt.basedir)
         new_signature = wt.branch.repository.revision_store.get('A',
             'sig').read()
@@ -320,6 +324,24 @@
         self.assertEqual(committed.properties["branch-nick"], 
                          "My happy branch")
 
+    def test_create_open_branch_uses_repository(self):
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        repo.bzrdir.root_transport.mkdir('child')
+        child_dir = self.bzrdir_format.initialize('child')
+        try:
+            child_branch = self.branch_format.initialize(child_dir)
+        except errors.UninitializableFormat:
+            # branch references are not default init'able.
+            return
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         child_branch.repository.bzrdir.root_transport.base)
+        child_branch = bzrlib.branch.Branch.open(self.get_url('child'))
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         child_branch.repository.bzrdir.root_transport.base)
+
 
 class ChrootedTests(TestCaseWithBranch):
     """A support class that provides readonly urls outside the local namespace.

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-02-17 06:14:04 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-02-21 01:05:33 +0000
@@ -23,6 +23,7 @@
 import bzrlib.branch
 import bzrlib.bzrdir as bzrdir
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.check import check
 from bzrlib.commit import commit
 import bzrlib.errors as errors
 from bzrlib.errors import (FileExists,
@@ -32,11 +33,17 @@
                            NotBranchError,
                            )
 import bzrlib.repository as repository
-from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
+from bzrlib.tests import (
+                          ChrootedTestCase,
+                          TestCase,
+                          TestCaseWithTransport,
+                          TestSkipped,
+                          )
 from bzrlib.trace import mutter
 import bzrlib.transactions as transactions
 import bzrlib.transport as transport
 from bzrlib.transport import get_transport
+import bzrlib.ui as ui
 from bzrlib.upgrade import upgrade
 import bzrlib.workingtree as workingtree
 
@@ -105,6 +112,14 @@
         self.assertNotEqual(dir.transport.base, target.transport.base)
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
     
+    def test_clone_bzrdir_empty_force_new_ignored(self):
+        # the force_new_repo parameter should have no effect on an empty
+        # bzrdir's clone logic
+        dir = self.make_bzrdir('source')
+        target = dir.clone(self.get_url('target'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+    
     def test_clone_bzrdir_repository(self):
         dir = self.make_bzrdir('source')
         repo = dir.create_repository()
@@ -118,6 +133,60 @@
         self.assertNotEqual(dir.transport.base, target.transport.base)
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
 
+    def test_clone_bzrdir_repository_under_shared(self):
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        # add some content to differentiate from an empty repository.
+        repo.control_weaves.add_text('inventory',
+                                     "A",
+                                     [],
+                                     [],
+                                     repo.get_transaction())
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.clone(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+
+    def test_clone_bzrdir_repository_branch_both_under_shared(self):
+        try:
+            shared_repo = self.make_repository('shared', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        tree.bzrdir.open_repository().copy_content_into(shared_repo)
+        dir = self.make_bzrdir('shared/source')
+        dir.create_branch()
+        target = dir.clone(self.get_url('shared/target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertNotEqual(dir.transport.base, shared_repo.bzrdir.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+        
+    def test_clone_bzrdir_repository_under_shared_force_new_repo(self):
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        # add some content to differentiate from an empty repository.
+        repo.control_weaves.add_text('inventory',
+                                     "A",
+                                     [],
+                                     [],
+                                     repo.get_transaction())
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.clone(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
     def test_clone_bzrdir_repository_revision(self):
         # test for revision limiting, [smoke test, not corner case checks].
         # make a repository with some revisions,
@@ -150,6 +219,45 @@
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
                                     ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
 
+    def test_clone_bzrdir_branch_and_repo_into_shared_repo(self):
+        # by default cloning into a shared repo uses the shared repo.
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+        self.assertEqual(source.revision_history(),
+                         target.open_branch().revision_history())
+
+    def test_clone_bzrdir_branch_and_repo_into_shared_repo_force_new_repo(self):
+        # by default cloning into a shared repo uses the shared repo.
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        target.open_repository()
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
     def test_clone_bzrdir_branch_reference(self):
         # cloning should preserve the reference status of the branch in a bzrdir
         referenced_branch = self.make_branch('referencced')
@@ -265,6 +373,31 @@
         target.open_repository()
         target.open_branch()
         target.open_workingtree()
+
+    def test_sprout_bzrdir_empty_under_shared_repo(self):
+        # sprouting an empty dir into a repo uses the repo
+        dir = self.make_bzrdir('source')
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+        target.open_branch()
+        target.open_workingtree()
+
+    def test_sprout_bzrdir_empty_under_shared_repo(self):
+        # the force_new_repo parameter should force use of a new repo in an empty
+        # bzrdir's sprout logic
+        dir = self.make_bzrdir('source')
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        target.open_repository()
+        target.open_branch()
+        target.open_workingtree()
     
     def test_sprout_bzrdir_repository(self):
         dir = self.make_bzrdir('source')
@@ -279,6 +412,64 @@
         self.assertNotEqual(dir.transport.base, target.transport.base)
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
 
+    def test_sprout_bzrdir_with_repository_to_shared(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_repository_branch_both_under_shared(self):
+        try:
+            shared_repo = self.make_repository('shared', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        tree.bzrdir.open_repository().copy_content_into(shared_repo)
+        dir = self.make_bzrdir('shared/source')
+        dir.create_branch()
+        target = dir.sprout(self.get_url('shared/target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertNotEqual(dir.transport.base, shared_repo.bzrdir.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_repository_under_shared_force_new_repo(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertFalse(shared_repo.has_revision('1'))
+
     def test_sprout_bzrdir_repository_revision(self):
         # test for revision limiting, [smoke test, not corner case checks].
         # make a repository with some revisions,
@@ -310,6 +501,43 @@
         self.assertNotEqual(dir.transport.base, target.transport.base)
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
 
+    def test_sprout_bzrdir_branch_and_repo_shared(self):
+        # sprouting a branch with a repo into a shared repo uses the shared
+        # repo
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_and_repo_shared_force_new_repo(self):
+        # sprouting a branch with a repo into a shared repo uses the shared
+        # repo
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertFalse(shared_repo.has_revision('1'))
+
     def test_sprout_bzrdir_branch_reference(self):
         # sprouting should create a repository if needed and a sprouted branch.
         referenced_branch = self.make_branch('referencced')
@@ -329,6 +557,57 @@
         # place
         target.open_repository()
 
+    def test_sprout_bzrdir_branch_reference_shared(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        referenced_tree = self.make_branch_and_tree('referenced')
+        referenced_tree.commit('1', rev_id='1', allow_pointless=True)
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_tree.branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and we want no repository as the target is shared
+        self.assertRaises(errors.NoRepositoryPresent, 
+                          target.open_repository)
+        # and we want revision '1' in the shared repo
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_reference_shared_force_new_repo(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        referenced_tree = self.make_branch_and_tree('referenced')
+        referenced_tree.commit('1', rev_id='1', allow_pointless=True)
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_tree.branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and we want revision '1' in the new repo
+        self.assertTrue(target.open_repository().has_revision('1'))
+        # but not the shared one
+        self.assertFalse(shared_repo.has_revision('1'))
+
     def test_sprout_bzrdir_branch_revision(self):
         # test for revision limiting, [smoke test, not corner case checks].
         # make a repository with some revisions,
@@ -472,7 +751,7 @@
                           get_transport(self.get_readonly_url()))
 
     def test_create_branch(self):
-        # a bzrdir can construct a repository for itself.
+        # a bzrdir can construct a branch and repository for itself.
         if not self.bzrdir_format.is_supported():
             # unsupported formats are not loopback testable
             # because the default open will not open them and
@@ -642,3 +921,156 @@
         self.assertEqual(dir.root_transport.base,
                          get_transport(self.get_url('.')).base)
 
+    def test_find_repository_no_repo_under_standalone_branch(self):
+        # finding a repo stops at standalone branches even if there is a
+        # higher repository available.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate/child')
+        made_control = self.bzrdir_format.initialize(url)
+        made_control.create_repository()
+        innermost_control = self.bzrdir_format.initialize(
+            self.get_url('intermediate/child'))
+        try:
+            child_repo = innermost_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        self.assertRaises(errors.NoRepositoryPresent,
+                          innermost_control.find_repository)
+
+    def test_find_repository_containing_shared_repository(self):
+        # find repo inside a shared repo with an empty control dir
+        # returns the shared repo.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('childbzrdir')
+        get_transport(self.get_url()).mkdir('childbzrdir')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            child_repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        found_repo = made_control.find_repository()
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        
+    def test_find_repository_standalone_with_containing_shared_repository(self):
+        # find repo inside a standalone repo inside a shared repo finds the standalone repo
+        try:
+            containing_repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        child_repo = self.make_repository('childrepo')
+        opened_control = bzrdir.BzrDir.open(self.get_url('childrepo'))
+        found_repo = opened_control.find_repository()
+        self.assertEqual(child_repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+
+    def test_find_repository_shared_within_shared_repository(self):
+        # find repo at a shared repo inside a shared repo finds the inner repo
+        try:
+            containing_repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('childrepo')
+        get_transport(self.get_url()).mkdir('childrepo')
+        child_control = self.bzrdir_format.initialize(url)
+        child_repo = child_control.create_repository(shared=True)
+        opened_control = bzrdir.BzrDir.open(self.get_url('childrepo'))
+        found_repo = opened_control.find_repository()
+        self.assertEqual(child_repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        self.assertNotEqual(child_repo.bzrdir.root_transport.base,
+                            containing_repo.bzrdir.root_transport.base)
+
+    def test_find_repository_with_nested_dirs_works(self):
+        # find repo inside a bzrdir inside a bzrdir inside a shared repo 
+        # finds the outer shared repo.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate/child')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            child_repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        innermost_control = self.bzrdir_format.initialize(
+            self.get_url('intermediate/child'))
+        try:
+            child_repo = innermost_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        found_repo = innermost_control.find_repository()
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        
+    def test_can_and_needs_format_conversion(self):
+        # check that we can ask an instance if its upgradable
+        dir = self.make_bzrdir('.')
+        if dir.can_convert_format():
+            # if its updatable there must be an updater
+            self.assertTrue(isinstance(dir._format.get_converter(),
+                                       bzrdir.Converter))
+        dir.needs_format_conversion(None)
+
+    def test_upgrade_new_instance(self):
+        """Does an available updater work ?."""
+        dir = self.make_bzrdir('.')
+        if dir.can_convert_format():
+            dir._format.get_converter(None).convert(dir, ui.ui_factory.progress_bar())
+            # and it should pass 'check' now.
+            check(bzrdir.BzrDir.open(self.get_url('.')).open_branch(), False)
+
+
+class ChrootedBzrDirTests(ChrootedTestCase):
+
+    def test_find_repository_no_repository(self):
+        # loopback test to check the current format fails to find a 
+        # share repository correctly.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # supported formats must be able to init and open
+        url = self.get_url('subdir')
+        get_transport(self.get_url()).mkdir('subdir')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        opened_control = bzrdir.BzrDir.open(self.get_readonly_url('subdir'))
+        self.assertRaises(errors.NoRepositoryPresent,
+                          opened_control.find_repository)
+

=== modified file 'bzrlib/tests/repository_implementations/test_fileid_involved.py'
--- bzrlib/tests/repository_implementations/test_fileid_involved.py	2006-02-14 17:19:40 +0000
+++ bzrlib/tests/repository_implementations/test_fileid_involved.py	2006-02-21 01:05:33 +0000
@@ -205,10 +205,11 @@
                                  'c-funky<file-id> quiji%bo'])
         main_wt.commit("Commit one", rev_id="rev-A")
 
-        branch2_branch = main_branch.clone("branch2")
+        branch2_bzrdir = main_branch.bzrdir.sprout("branch2")
+        branch2_branch = branch2_bzrdir.open_branch()
+        branch2_wt = branch2_bzrdir.open_workingtree()
         os.chmod("branch2/b",0770)
-        branch2_branch.working_tree().commit("branch2, Commit one", 
-                                             rev_id="rev-J")
+        branch2_wt.commit("branch2, Commit one", rev_id="rev-J")
 
         self.merge(branch2_branch, main_wt)
         os.chmod("main/b",0660)

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2006-02-13 21:52:05 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2006-02-20 00:29:35 +0000
@@ -125,7 +125,7 @@
                          repository.RepositoryFormat.find_format(opened_control))
 
     def test_create_repository(self):
-        # a repository can be constructedzrdir can construct a repository for itself.
+        # bzrdir can construct a repository for itself.
         if not self.bzrdir_format.is_supported():
             # unsupported formats are not loopback testable
             # because the default open will not open them and
@@ -136,6 +136,25 @@
         made_repo = made_control.create_repository()
         self.failUnless(isinstance(made_repo, repository.Repository))
         self.assertEqual(made_control, made_repo.bzrdir)
+        
+    def test_create_repository_shared(self):
+        # bzrdir can construct a shared repository.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        try:
+            made_repo = made_control.create_repository(shared=True)
+        except errors.IncompatibleFormat:
+            # not all repository formats understand being shared, or
+            # may only be shared in some circumstances.
+            return
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        self.assertTrue(made_repo.is_shared())
 
     def test_revision_tree(self):
         wt = self.make_branch_and_tree('.')
@@ -176,6 +195,16 @@
         # makes a this-version repo:
         repo_c = self.make_repository('c')
         check_push_rev1(repo_c)
+        
+    def test_fetch_missing_revision_same_location_fails(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        self.assertRaises(errors.NoSuchRevision, repo_b.fetch, repo_a, revision_id='XXX')
+
+    def test_fetch_same_location_trivial_works(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        repo_a.fetch(repo_b)
 
     def test_clone_bzrdir_repository_revision(self):
         # make a repository with some revisions,
@@ -200,6 +229,23 @@
         target = source.bzrdir.clone(self.get_url('target'), basis=tree.bzrdir)
         self.assertTrue(target.open_repository().has_revision('2'))
 
+    def test_clone_shared_no_tree(self):
+        # cloning a shared repository keeps it shared
+        # and preserves the make_working_tree setting.
+        made_control = self.make_bzrdir('source')
+        try:
+            made_repo = made_control.create_repository(shared=True)
+        except errors.IncompatibleFormat:
+            # not all repository formats understand being shared, or
+            # may only be shared in some circumstances.
+            return
+        made_repo.set_make_working_trees(False)
+        result = made_control.clone(self.get_url('target'))
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        self.assertTrue(result.open_repository().is_shared())
+        self.assertFalse(result.open_repository().make_working_trees())
+
 
 class TestCaseWithComplexRepository(TestCaseWithRepository):
 
@@ -261,4 +307,3 @@
         # get_ancestry(missing revision)-> NoSuchRevision
         self.assertRaises(errors.NoSuchRevision,
                           self.bzrdir.open_repository().get_ancestry, 'orphan')
-        

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2006-02-13 21:52:05 +0000
+++ bzrlib/tests/test_bzrdir.py	2006-02-17 04:17:09 +0000
@@ -66,6 +66,10 @@
         """See BzrDir.create_repository."""
         return "A repository"
 
+    def open_repository(self):
+        """See BzrDir.open_repository."""
+        return "A repository"
+
     def create_branch(self):
         """See BzrDir.create_branch."""
         return SampleBranch(self)
@@ -157,7 +161,20 @@
         finally:
             bzrdir.BzrDirFormat.set_default_format(old_format)
 
-    def test_create_branch_and_repo(self):
+    def test_create_repository_under_shared(self):
+        # an explicit create_repository always does so.
+        # we trust the format is right from the 'create_repository test'
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            repo = bzrdir.BzrDir.create_repository(self.get_url('child'))
+            self.assertTrue(isinstance(repo, repository.Repository))
+            self.assertTrue(repo.bzrdir.root_transport.base.endswith('child/'))
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_and_repo_uses_default(self):
         format = SampleBzrDirFormat()
         old_format = bzrdir.BzrDirFormat.get_default_format()
         bzrdir.BzrDirFormat.set_default_format(format)
@@ -167,6 +184,32 @@
         finally:
             bzrdir.BzrDirFormat.set_default_format(old_format)
 
+    def test_create_branch_and_repo_under_shared(self):
+        # creating a branch and repo in a shared repo uses the
+        # shared repository
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url('child'))
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_and_repo_under_shared_force_new(self):
+        # creating a branch and repo in a shared repo can be forced to 
+        # make a new repo
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url('child'),
+                                                          force_new_repo=True)
+            branch.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
     def test_create_standalone_working_tree(self):
         format = SampleBzrDirFormat()
         old_format = bzrdir.BzrDirFormat.get_default_format()
@@ -182,6 +225,109 @@
         finally:
             bzrdir.BzrDirFormat.set_default_format(old_format)
 
+    def test_create_standalone_working_tree_under_shared_repo(self):
+        # create standalone working tree always makes a repo.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            # note this is deliberately readonly, as this failure should 
+            # occur before any writes.
+            self.assertRaises(errors.NotLocalUrl,
+                              bzrdir.BzrDir.create_standalone_workingtree,
+                              self.get_readonly_url('child'))
+            tree = bzrdir.BzrDir.create_standalone_workingtree('child')
+            tree.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience(self):
+        # outside a repo the default conveniencec output is a repo+branch_tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            branch = bzrdir.BzrDir.create_branch_convenience('.')
+            branch.bzrdir.open_workingtree()
+            branch.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child')
+            branch.bzrdir.open_workingtree()
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+            
+    def test_create_branch_convenience_under_shared_repo_force_no_tree(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy but we can override that
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_tree=False)
+            self.assertRaises(errors.NoWorkingTree,
+                              branch.bzrdir.open_workingtree)
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+            
+    def test_create_branch_convenience_under_shared_repo_no_tree_policy(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            repo = self.make_repository('.', shared=True)
+            repo.set_make_working_trees(False)
+            branch = bzrdir.BzrDir.create_branch_convenience('child')
+            self.assertRaises(errors.NoWorkingTree,
+                              branch.bzrdir.open_workingtree)
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo_no_tree_policy_force_tree(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy but we can override that
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            repo = self.make_repository('.', shared=True)
+            repo.set_make_working_trees(False)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_tree=True)
+            branch.bzrdir.open_workingtree()
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo_force_new_repo(self):
+        # inside a repo the default convenience output is overridable to give
+        # repo+branch+tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_repo=True)
+            branch.bzrdir.open_repository()
+            branch.bzrdir.open_workingtree()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
 
 class ChrootedTests(TestCaseWithTransport):
     """A support class that provides readonly urls outside the local namespace.
@@ -207,6 +353,19 @@
         branch, relpath = bzrdir.BzrDir.open_containing(self.get_readonly_url('g/p/q'))
         self.assertEqual('g/p/q', relpath)
 
+    def test_open_containing_from_transport(self):
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing_from_transport,
+                          get_transport(self.get_readonly_url('')))
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing_from_transport,
+                          get_transport(self.get_readonly_url('g/p/q')))
+        control = bzrdir.BzrDir.create(self.get_url())
+        branch, relpath = bzrdir.BzrDir.open_containing_from_transport(
+            get_transport(self.get_readonly_url('')))
+        self.assertEqual('', relpath)
+        branch, relpath = bzrdir.BzrDir.open_containing_from_transport(
+            get_transport(self.get_readonly_url('g/p/q')))
+        self.assertEqual('g/p/q', relpath)
+
 
 class TestMeta1DirFormat(TestCaseWithTransport):
     """Tests specific to the meta1 dir format."""
@@ -226,3 +385,74 @@
         self.assertEqual(checkout_base, dir.get_workingtree_transport(None).base)
         self.assertEqual(checkout_base,
                          dir.get_workingtree_transport(workingtree.WorkingTreeFormat3()).base)
+
+        
+class TestFormat5(TestCaseWithTransport):
+    """Tests specific to the version 5 bzrdir format."""
+
+    def test_same_lockfiles_between_tree_repo_branch(self):
+        # this checks that only a single lockfiles instance is created 
+        # for format 5 objects
+        dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+        def check_dir_components_use_same_lock(dir):
+            ctrl_1 = dir.open_repository().control_files
+            ctrl_2 = dir.open_branch().control_files
+            ctrl_3 = dir.open_workingtree()._control_files
+            self.assertTrue(ctrl_1 is ctrl_2)
+            self.assertTrue(ctrl_2 is ctrl_3)
+        check_dir_components_use_same_lock(dir)
+        # and if we open it normally.
+        dir = bzrdir.BzrDir.open(self.get_url())
+        check_dir_components_use_same_lock(dir)
+    
+    def test_can_convert(self):
+        # format 5 dirs are convertable
+        dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+        self.assertTrue(dir.can_convert_format())
+    
+    def test_needs_conversion(self):
+        # format 5 dirs need a conversion if they are not the default.
+        # and they start of not the default.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirFormat5())
+        try:
+            dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+            self.assertFalse(dir.needs_format_conversion())
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+        self.assertTrue(dir.needs_format_conversion())
+
+
+class TestFormat6(TestCaseWithTransport):
+    """Tests specific to the version 6 bzrdir format."""
+
+    def test_same_lockfiles_between_tree_repo_branch(self):
+        # this checks that only a single lockfiles instance is created 
+        # for format 6 objects
+        dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        def check_dir_components_use_same_lock(dir):
+            ctrl_1 = dir.open_repository().control_files
+            ctrl_2 = dir.open_branch().control_files
+            ctrl_3 = dir.open_workingtree()._control_files
+            self.assertTrue(ctrl_1 is ctrl_2)
+            self.assertTrue(ctrl_2 is ctrl_3)
+        check_dir_components_use_same_lock(dir)
+        # and if we open it normally.
+        dir = bzrdir.BzrDir.open(self.get_url())
+        check_dir_components_use_same_lock(dir)
+    
+    def test_can_convert(self):
+        # format 6 dirs are convertable
+        dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        self.assertTrue(dir.can_convert_format())
+    
+    def test_needs_conversion(self):
+        # format 6 dirs need an conversion if they are not the default.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+            self.assertTrue(dir.needs_format_conversion())
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+        self.assertFalse(dir.needs_format_conversion())

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2006-02-10 11:03:38 +0000
+++ bzrlib/tests/test_errors.py	2006-02-16 08:18:32 +0000
@@ -29,3 +29,10 @@
         error = errors.NoRepositoryPresent(dir)
         self.assertNotEqual(-1, str(error).find(repr(dir.transport.clone('..').base)))
         self.assertEqual(-1, str(error).find(repr(dir.transport.base)))
+
+    def test_up_to_date(self):
+        error = errors.UpToDateFormat(bzrdir.BzrDirFormat4())
+        self.assertEqualDiff("The branch format Bazaar-NG branch, "
+                             "format 0.0.4 is already at the most "
+                             "recent format.",
+                             str(error))

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2006-02-06 03:45:27 +0000
+++ bzrlib/tests/test_repository.py	2006-02-15 08:11:37 +0000
@@ -69,7 +69,7 @@
         """See RepositoryFormat.get_format_string()."""
         return "Sample .bzr repository format."
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, shared=False):
         """Initialize a repository in a BzrDir"""
         t = a_bzrdir.get_repository_transport(self)
         t.put('format', StringIO(self.get_format_string()))
@@ -144,16 +144,67 @@
     def test_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = repository.RepositoryFormat7().initialize(control)
-        # we want:
-        # format 'Bazaar-NG Repository format 7'
-        # lock ''
-        # inventory.weave == empty_weave
-        # empty revision-store directory
-        # empty weaves directory
-        t = control.get_repository_transport(None)
-        self.assertEqualDiff('Bazaar-NG Repository format 7',
-                             t.get('format').read())
-        self.assertEqualDiff('', t.get('lock').read())
+        # in case of side effects of locking.
+        repo.lock_write()
+        repo.unlock()
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        self.assertEqualDiff('', t.get('lock').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+    def test_shared_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+    def test_shared_no_tree_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        repo.set_make_working_trees(False)
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertEqualDiff('', t.get('no-working-trees').read())
+        repo.set_make_working_trees(True)
+        self.assertFalse(t.has('no-working-trees'))
         self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
         self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
         self.assertEqualDiff('# bzr weave file v5\n'

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2005-11-30 16:41:08 +0000
+++ bzrlib/tests/test_ui.py	2006-02-16 05:54:02 +0000
@@ -18,8 +18,10 @@
 """
 
 import os
+from StringIO import StringIO
 import sys
 
+from bzrlib.progress import TTYProgressBar
 from bzrlib.tests import TestCase
 from bzrlib.ui import SilentUIFactory
 from bzrlib.ui.text import TextUIFactory
@@ -50,3 +52,13 @@
         #                                   user=u'some\u1234')
         #                  , 'bogus')
 
+
+    def test_progress_note(self):
+        stderr = StringIO()
+        stdout = StringIO()
+        ui = TextUIFactory()
+        pb = TTYProgressBar(to_file=stderr, to_messages_file=stdout)
+        result = pb.note('t')
+        self.assertEqual(None, result)
+        self.assertEqual("t\n", stdout.getvalue())
+        self.assertEqual("\r                                                                               \r", stderr.getvalue())

=== modified file 'bzrlib/tests/test_upgrade.py'
--- bzrlib/tests/test_upgrade.py	2006-02-13 21:52:05 +0000
+++ bzrlib/tests/test_upgrade.py	2006-02-16 11:26:39 +0000
@@ -119,6 +119,13 @@
         self.failUnlessExists(
             '.bzr/weaves/de/dir-20051005095101-da1441ea3fa6917a.weave')
 
+    def test_upgrade_to_meta_sets_workingtree_last_revision(self):
+        self.build_tree_contents(_upgrade_dir_template)
+        upgrade('.', bzrdir.BzrDirMetaFormat1)
+        tree = workingtree.WorkingTree.open('.')
+        self.assertEqual(tree.last_revision(),
+                         tree.branch.revision_history()[-1])
+
 
 _upgrade1_template = \
      [

=== modified file 'bzrlib/tests/workingtree_implementations/__init__.py'
--- bzrlib/tests/workingtree_implementations/__init__.py	2006-02-03 02:18:48 +0000
+++ bzrlib/tests/workingtree_implementations/__init__.py	2006-02-16 02:53:00 +0000
@@ -24,21 +24,50 @@
 rather than in tests/workingtree_implementations/*.py.
 """
 
-from bzrlib.workingtree import (WorkingTreeFormat,
-                                WorkingTreeTestProviderAdapter,
-                                _legacy_formats,
-                                )
+import bzrlib.errors as errors
+from bzrlib.transport import get_transport
 from bzrlib.tests import (
                           adapt_modules,
                           default_transport,
+                          TestCaseWithTransport,
                           TestLoader,
                           TestSuite,
                           )
+from bzrlib.workingtree import (WorkingTreeFormat,
+                                WorkingTreeTestProviderAdapter,
+                                _legacy_formats,
+                                )
+
+
+class TestCaseWithWorkingTree(TestCaseWithTransport):
+
+    def make_bzrdir(self, relpath):
+        # todo factor out into bzrdir-using-implementations-tests-base-class
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except errors.FileExists:
+                    pass
+            return self.bzrdir_format.initialize(url)
+        except errors.UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+    def make_branch_and_tree(self, relpath):
+        made_control = self.make_bzrdir(relpath)
+        made_control.create_repository()
+        made_control.create_branch()
+        return self.workingtree_format.initialize(made_control)
 
 
 def test_suite():
     result = TestSuite()
     test_workingtree_implementations = [
+        'bzrlib.tests.workingtree_implementations.test_is_control_filename',
         'bzrlib.tests.workingtree_implementations.test_workingtree',
         ]
     adapter = WorkingTreeTestProviderAdapter(

=== added file 'bzrlib/tests/workingtree_implementations/test_is_control_filename.py'
--- bzrlib/tests/workingtree_implementations/test_is_control_filename.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/workingtree_implementations/test_is_control_filename.py	2006-02-16 02:53:00 +0000
@@ -0,0 +1,55 @@
+# (C) 2006 Canonical Ltd
+# Authors:  Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from cStringIO import StringIO
+import os
+
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
+from bzrlib.errors import NotBranchError, NotVersionedError
+from bzrlib.osutils import basename
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
+from bzrlib.trace import mutter
+from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
+
+
+class TestIsControlFilename(TestCaseWithWorkingTree):
+
+    def validate_tree_is_controlfilename(self, tree):
+        """check that 'tree' obeys the contract for is_control_filename."""
+        bzrdirname = basename(tree.bzrdir.transport.base[:-1])
+        self.assertTrue(tree.is_control_filename(bzrdirname))
+        self.assertTrue(tree.is_control_filename(bzrdirname + '/subdir'))
+        self.assertFalse(tree.is_control_filename('dir/' + bzrdirname))
+        self.assertFalse(tree.is_control_filename('dir/' + bzrdirname + '/sub'))
+
+    def test_dotbzr_is_control_in_cwd(self):
+        tree = self.make_branch_and_tree('.')
+        self.validate_tree_is_controlfilename(tree)
+        
+    def test_dotbzr_is_control_in_subdir(self):
+        tree = self.make_branch_and_tree('subdir')
+        self.validate_tree_is_controlfilename(tree)
+        

=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-02-13 21:52:05 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-02-16 02:53:00 +0000
@@ -26,39 +26,14 @@
 import bzrlib.errors as errors
 from bzrlib.errors import NotBranchError, NotVersionedError
 from bzrlib.osutils import pathjoin, getcwd, has_symlinks
-from bzrlib.tests import TestCaseWithTransport, TestSkipped
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
-from bzrlib.transport import get_transport
 import bzrlib.workingtree as workingtree
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
                                 WorkingTree)
 
 
-class TestCaseWithWorkingTree(TestCaseWithTransport):
-
-    def make_bzrdir(self, relpath):
-        # todo factor out into bzrdir-using-implementations-tests-base-class
-        try:
-            url = self.get_url(relpath)
-            segments = url.split('/')
-            if segments and segments[-1] not in ('', '.'):
-                parent = '/'.join(segments[:-1])
-                t = get_transport(parent)
-                try:
-                    t.mkdir(segments[-1])
-                except errors.FileExists:
-                    pass
-            return self.bzrdir_format.initialize(url)
-        except errors.UninitializableFormat:
-            raise TestSkipped("Format %s is not initializable.")
-
-    def make_branch_and_tree(self, relpath):
-        made_control = self.make_bzrdir(relpath)
-        made_control.create_repository()
-        made_control.create_branch()
-        return self.workingtree_format.initialize(made_control)
-
-
 class TestWorkingTree(TestCaseWithWorkingTree):
 
     def test_listfiles(self):
@@ -170,7 +145,7 @@
         pause()
         sha = tree.get_file_sha1(tree.path2id('hello.txt'))
         self.assertEqual(1, tree._hashcache.miss_count)
-        tree2 = WorkingTree.open('.', tree.branch)
+        tree2 = WorkingTree.open('.')
         sha2 = tree2.get_file_sha1(tree2.path2id('hello.txt'))
         self.assertEqual(0, tree2._hashcache.miss_count)
         self.assertEqual(1, tree2._hashcache.hit_count)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2006-02-17 15:56:04 +0000
+++ bzrlib/transform.py	2006-02-21 01:05:33 +0000
@@ -18,7 +18,6 @@
 import errno
 from stat import S_ISREG
 
-from bzrlib import BZRDIR
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
                            ReusingTransform, NotVersionedError, CantMoveRoot,
                            ExistingLimbo, ImmortalLimbo)
@@ -502,7 +501,7 @@
             
         for child in children:
             childpath = joinpath(path, child)
-            if childpath == BZRDIR:
+            if self._tree.is_control_filename(childpath):
                 continue
             yield self.get_tree_path_id(childpath)
 

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2006-02-14 17:19:40 +0000
+++ bzrlib/transport/__init__.py	2006-02-21 01:05:33 +0000
@@ -422,6 +422,9 @@
             subtree.rmdir(dir)
         self.rmdir(relpath)
 
+    def __repr__(self):
+        return "<%s.%s url=%s>" % (self.__module__, self.__class__.__name__, self.base)
+
     def stat(self, relpath):
         """Return the stat information for a file.
         WARNING: This may not be implementable for all protocols, so use

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2005-11-30 16:41:08 +0000
+++ bzrlib/ui/__init__.py	2006-02-16 08:18:32 +0000
@@ -67,3 +67,5 @@
 
 
 ui_factory = SilentUIFactory()
+"""IMPORTANT: never import this symbol directly. ONLY ever access it as 
+ui.ui_factory."""

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2006-02-14 17:19:40 +0000
+++ bzrlib/upgrade.py	2006-02-21 01:05:33 +0000
@@ -19,431 +19,50 @@
 # change upgrade from .bzr to create a '.bzr-new', then do a bait and switch.
 
 
-# To make this properly useful
-#
-# 1. assign text version ids, and put those text versions into
-#    the inventory as they're converted.
-#
-# 2. keep track of the previous version of each file, rather than
-#    just using the last one imported
-#
-# 3. assign entry versions when files are added, renamed or moved.
-#
-# 4. when merged-in versions are observed, walk down through them
-#    to discover everything, then commit bottom-up
-#
-# 5. track ancestry as things are merged in, and commit that in each
-#    revision
-#
-# Perhaps it's best to first walk the whole graph and make a plan for
-# what should be imported in what order?  Need a kind of topological
-# sort of all revisions.  (Or do we, can we just before doing a revision
-# see that all its parents have either been converted or abandoned?)
-
-
-# Cannot import a revision until all its parents have been
-# imported.  in other words, we can only import revisions whose
-# parents have all been imported.  the first step must be to
-# import a revision with no parents, of which there must be at
-# least one.  (So perhaps it's useful to store forward pointers
-# from a list of parents to their children?)
-#
-# Another (equivalent?) approach is to build up the ordered
-# ancestry list for the last revision, and walk through that.  We
-# are going to need that.
-#
-# We don't want to have to recurse all the way back down the list.
-#
-# Suppose we keep a queue of the revisions able to be processed at
-# any point.  This starts out with all the revisions having no
-# parents.
-#
-# This seems like a generally useful algorithm...
-#
-# The current algorithm is dumb (O(n**2)?) but will do the job, and
-# takes less than a second on the bzr.dev branch.
-
-# This currently does a kind of lazy conversion of file texts, where a
-# new text is written in every version.  That's unnecessary but for
-# the moment saves us having to worry about when files need new
-# versions.
-
-from cStringIO import StringIO
-import os
-import tempfile
-import sys
-from stat import *
-
-import bzrlib
-from bzrlib.branch import Branch
-import bzrlib.bzrdir as bzrdir
-from bzrlib.bzrdir import BzrDirFormat, BzrDirFormat4, BzrDirFormat5, BzrDirFormat6
+from bzrlib.bzrdir import ConvertBzrDir4To5, ConvertBzrDir5To6, BzrDir, BzrDirFormat4, BzrDirFormat5
 import bzrlib.errors as errors
-from bzrlib.errors import NoSuchFile, UpgradeReadonly
-import bzrlib.hashcache as hashcache
-from bzrlib.lockable_files import LockableFiles
-from bzrlib.osutils import sha_strings, sha_string, pathjoin, abspath
-from bzrlib.ui import ui_factory
-from bzrlib.store.text import TextStore
-from bzrlib.store.weave import WeaveStore
-from bzrlib.trace import mutter, note, warning
-from bzrlib.transactions import PassThroughTransaction
 from bzrlib.transport import get_transport
-from bzrlib.transport.local import LocalTransport
-from bzrlib.weave import Weave
-from bzrlib.weavefile import read_weave, write_weave
-from bzrlib.xml4 import serializer_v4
-from bzrlib.xml5 import serializer_v5
+import bzrlib.ui as ui
 
 
 class Convert(object):
 
-    def __init__(self, transport):
-        self.base = transport.base
-        self.converted_revs = set()
-        self.absent_revisions = set()
-        self.text_count = 0
-        self.revisions = {}
-        self.transport = transport
-        if self.transport.is_readonly():
-            raise UpgradeReadonly
-        self.control_files = LockableFiles(transport.clone(bzrlib.BZRDIR), 'branch-lock')
-        # Lock the branch (soon to be meta dir) to prevent anyone racing with us
-        # This is currently windows incompatible, it will deadlock. When the upgrade
-        # logic becomes format specific, then we can have the format know how to pass this
-        # on. Also note that we probably have an 'upgrade meta' which upgrades the constituent
-        # parts.
-        # FIXME: control files reuse
-        self.control_files.lock_write()
-        try:
-            self.convert()
-        finally:
-            self.control_files.unlock()
+    def __init__(self, url, format):
+        self.format = format
+        self.bzrdir = BzrDir.open_unsupported(url)
+        if self.bzrdir.root_transport.is_readonly():
+            raise errors.UpgradeReadonly
+        self.transport = self.bzrdir.root_transport
+        self.convert()
 
     def convert(self):
-        if not self._open_branch():
-            return
-        note('starting upgrade of %s', self.base)
+        self.pb = ui.ui_factory.progress_bar()
+        branch = self.bzrdir.open_branch()
+        if branch.bzrdir.root_transport.base != self.bzrdir.root_transport.base:
+            self.pb.note("This is a checkout. The branch (%s) needs to be "
+                         "upgraded separately.",
+                         branch.bzrdir.root_transport.base)
+        if not self.bzrdir.needs_format_conversion(self.format):
+            raise errors.UpToDateFormat(self.bzrdir._format)
+        if not self.bzrdir.can_convert_format():
+            raise errors.BzrError("cannot upgrade from branch format %s" %
+                           self.bzrdir._format)
+        self.pb.note('starting upgrade of %s', self.transport.base)
         self._backup_control_dir()
-        self.pb = ui_factory.progress_bar()
-        if isinstance(self.old_format, BzrDirFormat4):
-            note('starting upgrade from format 4 to 5')
-            if isinstance(self.transport, LocalTransport):
-                self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
-            self._convert_to_weaves()
-        if isinstance(self.old_format, BzrDirFormat5):
-            note('starting upgrade from format 5 to 6')
-            self._convert_to_prefixed()
-        note("finished")
-
-    def _convert_to_prefixed(self):
-        from bzrlib.store import hash_prefix
-        bzr_transport = self.transport.clone('.bzr')
-        bzr_transport.delete('branch-format')
-        for store_name in ["weaves", "revision-store"]:
-            note("adding prefixes to %s" % store_name) 
-            store_transport = bzr_transport.clone(store_name)
-            for filename in store_transport.list_dir('.'):
-                if (filename.endswith(".weave") or
-                    filename.endswith(".gz") or
-                    filename.endswith(".sig")):
-                    file_id = os.path.splitext(filename)[0]
-                else:
-                    file_id = filename
-                prefix_dir = hash_prefix(file_id)
-                # FIXME keep track of the dirs made RBC 20060121
-                try:
-                    store_transport.move(filename, prefix_dir + '/' + filename)
-                except NoSuchFile: # catches missing dirs strangely enough
-                    store_transport.mkdir(prefix_dir)
-                    store_transport.move(filename, prefix_dir + '/' + filename)
-        self.old_format = BzrDirFormat6()
-        self._set_new_format(self.old_format.get_format_string())
-        self.bzrdir = self.old_format.open(self.transport)
-        self.branch = self.bzrdir.open_branch()
-
-    def _convert_to_weaves(self):
-        note('note: upgrade may be faster if all store files are ungzipped first')
-        bzr_transport = self.transport.clone('.bzr')
-        try:
-            # TODO permissions
-            stat = bzr_transport.stat('weaves')
-            if not S_ISDIR(stat.st_mode):
-                bzr_transport.delete('weaves')
-                bzr_transport.mkdir('weaves')
-        except NoSuchFile:
-            bzr_transport.mkdir('weaves')
-        self.inv_weave = Weave('inventory')
-        # holds in-memory weaves for all files
-        self.text_weaves = {}
-        bzr_transport.delete('branch-format')
-        self._convert_working_inv()
-        rev_history = self.branch.revision_history()
-        # to_read is a stack holding the revisions we still need to process;
-        # appending to it adds new highest-priority revisions
-        self.known_revisions = set(rev_history)
-        self.to_read = rev_history[-1:]
-        while self.to_read:
-            rev_id = self.to_read.pop()
-            if (rev_id not in self.revisions
-                and rev_id not in self.absent_revisions):
-                self._load_one_rev(rev_id)
-        self.pb.clear()
-        to_import = self._make_order()
-        for i, rev_id in enumerate(to_import):
-            self.pb.update('converting revision', i, len(to_import))
-            self._convert_one_rev(rev_id)
-        self.pb.clear()
-        self._write_all_weaves()
-        self._write_all_revs()
-        note('upgraded to weaves:')
-        note('  %6d revisions and inventories' % len(self.revisions))
-        note('  %6d revisions not present' % len(self.absent_revisions))
-        note('  %6d texts' % self.text_count)
-        self._cleanup_spare_files_after_format4()
-        self.old_format = BzrDirFormat5()
-        self._set_new_format(self.old_format.get_format_string())
-        self.bzrdir = self.old_format.open(self.transport)
-        self.branch = self.bzrdir.open_branch()
-
-    def _open_branch(self):
-        self.old_format = BzrDirFormat.find_format(self.transport)
-        self.bzrdir = self.old_format.open(self.transport)
-        self.branch = self.bzrdir.open_branch()
-        if isinstance(self.old_format, BzrDirFormat6):
-            note('this branch is in the most current format (%s)', self.old_format)
-            return False
-        if (not isinstance(self.old_format, BzrDirFormat4) and
-            not isinstance(self.old_format, BzrDirFormat5) and
-            not isinstance(self.old_format, bzrdir.BzrDirMetaFormat1)):
-            raise errors.BzrError("cannot upgrade from branch format %s" %
-                           self.branch._branch_format)
-        return True
-
-    def _set_new_format(self, format):
-        self.branch.control_files.put_utf8('branch-format', format)
-
-    def _cleanup_spare_files_after_format4(self):
-        transport = self.transport.clone('.bzr')
-        # FIXME working tree upgrade foo.
-        for n in 'merged-patches', 'pending-merged-patches':
-            try:
-                ## assert os.path.getsize(p) == 0
-                transport.delete(n)
-            except NoSuchFile:
-                pass
-        transport.delete_tree('inventory-store')
-        transport.delete_tree('text-store')
+        while self.bzrdir.needs_format_conversion(self.format):
+            converter = self.bzrdir._format.get_converter(self.format)
+            self.bzrdir = converter.convert(self.bzrdir, self.pb)
+        self.pb.note("finished")
 
     def _backup_control_dir(self):
-        note('making backup of tree history')
+        self.pb.note('making backup of tree history')
         self.transport.copy_tree('.bzr', '.bzr.backup')
-        note('%s.bzr has been backed up to %s.bzr.backup',
+        self.pb.note('%s.bzr has been backed up to %s.bzr.backup',
              self.transport.base,
              self.transport.base)
-        note('if conversion fails, you can move this directory back to .bzr')
-        note('if it succeeds, you can remove this directory if you wish')
-
-    def _convert_working_inv(self):
-        branch = self.branch
-        inv = serializer_v4.read_inventory(branch.control_files.get('inventory'))
-        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
-        # FIXME inventory is a working tree change.
-        branch.control_files.put('inventory', new_inv_xml)
-
-    def _write_all_weaves(self):
-        bzr_transport = self.transport.clone('.bzr')
-        controlweaves = WeaveStore(bzr_transport, prefixed=False)
-        weave_transport = bzr_transport.clone('weaves')
-        weaves = WeaveStore(weave_transport, prefixed=False)
-        transaction = PassThroughTransaction()
-
-        controlweaves.put_weave('inventory', self.inv_weave, transaction)
-        i = 0
-        try:
-            for file_id, file_weave in self.text_weaves.items():
-                self.pb.update('writing weave', i, len(self.text_weaves))
-                weaves.put_weave(file_id, file_weave, transaction)
-                i += 1
-        finally:
-            self.pb.clear()
-
-    def _write_all_revs(self):
-        """Write all revisions out in new form."""
-        transport = self.transport.clone('.bzr')
-        transport.delete_tree('revision-store')
-        transport.mkdir('revision-store')
-        revision_transport = transport.clone('revision-store')
-        # TODO permissions
-        revision_store = TextStore(revision_transport,
-                                   prefixed=False,
-                                   compressed=True)
-        try:
-            for i, rev_id in enumerate(self.converted_revs):
-                self.pb.update('write revision', i, len(self.converted_revs))
-                rev_tmp = StringIO()
-                serializer_v5.write_revision(self.revisions[rev_id], rev_tmp)
-                rev_tmp.seek(0)
-                revision_store.add(rev_tmp, rev_id)
-        finally:
-            self.pb.clear()
-
-            
-    def _load_one_rev(self, rev_id):
-        """Load a revision object into memory.
-
-        Any parents not either loaded or abandoned get queued to be
-        loaded."""
-        self.pb.update('loading revision',
-                       len(self.revisions),
-                       len(self.known_revisions))
-        if not self.branch.repository.revision_store.has_id(rev_id):
-            self.pb.clear()
-            note('revision {%s} not present in branch; '
-                 'will be converted as a ghost',
-                 rev_id)
-            self.absent_revisions.add(rev_id)
-        else:
-            rev_xml = self.branch.repository.revision_store.get(rev_id).read()
-            rev = serializer_v4.read_revision_from_string(rev_xml)
-            for parent_id in rev.parent_ids:
-                self.known_revisions.add(parent_id)
-                self.to_read.append(parent_id)
-            self.revisions[rev_id] = rev
-
-
-    def _load_old_inventory(self, rev_id):
-        assert rev_id not in self.converted_revs
-        old_inv_xml = self.branch.repository.inventory_store.get(rev_id).read()
-        inv = serializer_v4.read_inventory_from_string(old_inv_xml)
-        rev = self.revisions[rev_id]
-        if rev.inventory_sha1:
-            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
-                'inventory sha mismatch for {%s}' % rev_id
-        return inv
-        
-
-    def _load_updated_inventory(self, rev_id):
-        assert rev_id in self.converted_revs
-        inv_xml = self.inv_weave.get_text(rev_id)
-        inv = serializer_v5.read_inventory_from_string(inv_xml)
-        return inv
-
-
-    def _convert_one_rev(self, rev_id):
-        """Convert revision and all referenced objects to new format."""
-        rev = self.revisions[rev_id]
-        inv = self._load_old_inventory(rev_id)
-        present_parents = [p for p in rev.parent_ids
-                           if p not in self.absent_revisions]
-        self._convert_revision_contents(rev, inv, present_parents)
-        self._store_new_weave(rev, inv, present_parents)
-        self.converted_revs.add(rev_id)
-
-
-    def _store_new_weave(self, rev, inv, present_parents):
-        # the XML is now updated with text versions
-        if __debug__:
-            for file_id in inv:
-                ie = inv[file_id]
-                if ie.kind == 'root_directory':
-                    continue
-                assert hasattr(ie, 'revision'), \
-                    'no revision on {%s} in {%s}' % \
-                    (file_id, rev.revision_id)
-        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
-        new_inv_sha1 = sha_string(new_inv_xml)
-        self.inv_weave.add(rev.revision_id, 
-                           present_parents,
-                           new_inv_xml.splitlines(True),
-                           new_inv_sha1)
-        rev.inventory_sha1 = new_inv_sha1
-
-    def _convert_revision_contents(self, rev, inv, present_parents):
-        """Convert all the files within a revision.
-
-        Also upgrade the inventory to refer to the text revision ids."""
-        rev_id = rev.revision_id
-        mutter('converting texts of revision {%s}',
-               rev_id)
-        parent_invs = map(self._load_updated_inventory, present_parents)
-        for file_id in inv:
-            ie = inv[file_id]
-            self._convert_file_version(rev, ie, parent_invs)
-
-    def _convert_file_version(self, rev, ie, parent_invs):
-        """Convert one version of one file.
-
-        The file needs to be added into the weave if it is a merge
-        of >=2 parents or if it's changed from its parent.
-        """
-        if ie.kind == 'root_directory':
-            return
-        file_id = ie.file_id
-        rev_id = rev.revision_id
-        w = self.text_weaves.get(file_id)
-        if w is None:
-            w = Weave(file_id)
-            self.text_weaves[file_id] = w
-        text_changed = False
-        previous_entries = ie.find_previous_heads(parent_invs, w)
-        for old_revision in previous_entries:
-                # if this fails, its a ghost ?
-                assert old_revision in self.converted_revs 
-        self.snapshot_ie(previous_entries, ie, w, rev_id)
-        del ie.text_id
-        assert getattr(ie, 'revision', None) is not None
-
-    def snapshot_ie(self, previous_revisions, ie, w, rev_id):
-        # TODO: convert this logic, which is ~= snapshot to
-        # a call to:. This needs the path figured out. rather than a work_tree
-        # a v4 revision_tree can be given, or something that looks enough like
-        # one to give the file content to the entry if it needs it.
-        # and we need something that looks like a weave store for snapshot to 
-        # save against.
-        #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))
-        if len(previous_revisions) == 1:
-            previous_ie = previous_revisions.values()[0]
-            if ie._unchanged(previous_ie):
-                ie.revision = previous_ie.revision
-                return
-        parent_indexes = map(w.lookup, previous_revisions)
-        if ie.has_text():
-            text = self.branch.repository.text_store.get(ie.text_id)
-            file_lines = text.readlines()
-            assert sha_strings(file_lines) == ie.text_sha1
-            assert sum(map(len, file_lines)) == ie.text_size
-            w.add(rev_id, parent_indexes, file_lines, ie.text_sha1)
-            self.text_count += 1
-        else:
-            w.add(rev_id, parent_indexes, [], None)
-        ie.revision = rev_id
-        ##mutter('import text {%s} of {%s}',
-        ##       ie.text_id, file_id)
-
-    def _make_order(self):
-        """Return a suitable order for importing revisions.
-
-        The order must be such that an revision is imported after all
-        its (present) parents.
-        """
-        todo = set(self.revisions.keys())
-        done = self.absent_revisions.copy()
-        o = []
-        while todo:
-            # scan through looking for a revision whose parents
-            # are all done
-            for rev_id in sorted(list(todo)):
-                rev = self.revisions[rev_id]
-                parent_ids = set(rev.parent_ids)
-                if parent_ids.issubset(done):
-                    # can take this one now
-                    o.append(rev_id)
-                    todo.remove(rev_id)
-                    done.add(rev_id)
-        return o
-
-
-def upgrade(url):
-    t = get_transport(url)
-    Convert(t)
+        self.pb.note('if conversion fails, you can move this directory back to .bzr')
+        self.pb.note('if it succeeds, you can remove this directory if you wish')
+
+def upgrade(url, format=None):
+    """Upgrade to format, or the default bzrdir format if not supplied."""
+    Convert(url, format)

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-02-15 14:43:26 +0000
+++ bzrlib/workingtree.py	2006-02-21 01:05:33 +0000
@@ -226,7 +226,7 @@
         assert isinstance(basedir, basestring), \
             "base directory %r is not a string" % basedir
         basedir = safe_unicode(basedir)
-        mutter("openeing working tree %r", basedir)
+        mutter("opening working tree %r", basedir)
         if deprecated_passed(branch):
             if not _internal:
                 warn("WorkingTree(..., branch=XXX) is deprecated as of bzr 0.8."
@@ -279,6 +279,19 @@
         self._inventory = inv
         self.path2id = self._inventory.path2id
 
+    def is_control_filename(self, filename):
+        """True if filename is the name of a control file in this tree.
+        
+        This is true IF and ONLY IF the filename is part of the meta data
+        that bzr controls in this tree. I.E. a random .bzr directory placed
+        on disk will not be a control file for this tree.
+        """
+        try:
+            self.bzrdir.transport.relpath(self.abspath(filename))
+            return True
+        except errors.PathNotChild:
+            return False
+
     @staticmethod
     def open(path=None, _unsupported=False):
         """Open an existing working tree at path.
@@ -519,7 +532,7 @@
 
         inv = self.read_working_inventory()
         for f,file_id in zip(files, ids):
-            if is_control_file(f):
+            if self.is_control_filename(f):
                 raise BzrError("cannot add control file %s" % quotefn(f))
 
             fp = splitpath(f)
@@ -614,7 +627,9 @@
                 ## TODO: If we find a subdirectory with its own .bzr
                 ## directory, then that is a separate tree and we
                 ## should exclude it.
-                if bzrlib.BZRDIR == f:
+
+                # the bzrdir for this tree
+                if self.bzrdir.transport.base.endswith(f + '/'):
                     continue
 
                 # path within tree
@@ -1126,9 +1141,11 @@
         
         # TODO: split this per format so there is no ugly if block
         if self._hashcache.needs_write and (
+            # dedicated lock files
             self._control_files._lock_count==1 or 
+            # shared lock files
             (self._control_files is self.branch.control_files and 
-             self._control_files._lock_count==2)):
+             self._control_files._lock_count==3)):
             self._hashcache.write()
         # reverse order of locking.
         result = self._control_files.unlock()
@@ -1204,13 +1221,15 @@
         if path.endswith(suffix):
             return path[:-len(suffix)]
 
+@deprecated_function(zero_eight)
 def is_control_file(filename):
+    """See WorkingTree.is_control_filename(filename)."""
     ## FIXME: better check
     filename = normpath(filename)
     while filename != '':
         head, tail = os.path.split(filename)
         ## mutter('check %r for control file' % ((head, tail),))
-        if tail == bzrlib.BZRDIR:
+        if tail == '.bzr':
             return True
         if filename == head:
             break
@@ -1403,6 +1422,9 @@
                            _format=self,
                            _bzrdir=a_bzrdir)
 
+    def __str__(self):
+        return self.get_format_string()
+
 
 # formats which have no format string are not discoverable
 # and not independently creatable, so are not registered.

=== removed directory 'patches'
